@echo off
break on
echo .
if exist %1.%2 goto begin
echo Procedure CEDGE produces a color edge-enhanced image for viewing by
echo program IMVIS.
echo .
echo USAGE:  cedge P1 P2 P3 P4 P5 P6 P7
echo .
echo P1 = file name prefix of input grid for shading
echo P2 = file name suffix of input grid for shading
echo P3 = complete file name of input grid for coloring
echo P4 = output image name
echo P5 = gradient level which appears black
echo P6 = number of colors in the output image
echo P7 = minimum number of pixels assigned to one color
echo .
echo EXAMPLE:  cedge test plg test.grd edge 100 240 5
echo .
goto done
:begin
echo . > temp.tmp
for %%f in (%1.gra) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%4.cmg %4.lbl) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%4.dat %4.pal) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%1.gra) do if exist %%f if exist temp.tmp del temp.tmp
for %%f in (%4.cmg %4.lbl) do if exist %%f if exist temp.tmp del temp.tmp
for %%f in (%4.dat %4.pal) do if exist %%f if exist temp.tmp del temp.tmp
if not exist temp.tmp echo .
if not exist temp.tmp echo Hit Ctrl-Break to exit, otherwise...
if not exist temp.tmp pause
echo %1.%2 > temp.tmp
echo %1.gra >> temp.tmp
echo gradient of %1.%2 >> temp.tmp
echo .
echo ** Running GRADIENT on the elevation grid **
gradient < temp.tmp >> nul
echo %3 > temp.tmp
echo .
echo ** Running RAINBOW on the coloring grid **
rainbow < temp.tmp >> nul
echo %1.gra > temp.tmp
echo %5 >> temp.tmp
echo .
echo ** Running CEE to combine color and shade grids **
cee < temp.tmp >> nul
del %1.gra
del red.grd
del green.grd
del blue.grd
if exist ered.img del ered.img
if exist egreen.img del egreen.img
if exist eblue.img del eblue.img
echo ered.grd > temp.tmp
echo ered.img >> temp.tmp
echo .
echo ** Running GRDREM on the red component **
grdrem < temp.tmp >> nul
del ered.grd
echo egreen.grd > temp.tmp
echo egreen.img >> temp.tmp
echo .
echo ** Running GRDREM on the green component **
grdrem < temp.tmp >> nul
del egreen.grd
echo eblue.grd > temp.tmp
echo eblue.img >> temp.tmp
echo .
echo ** Running GRDREM on the blue component **
grdrem < temp.tmp >> nul
del eblue.grd
echo ered.img > temp.tmp
echo egreen.img >> temp.tmp
echo eblue.img >> temp.tmp
echo %4.cmg >> temp.tmp
echo %3 > temp1.tmp
getdims < temp1.tmp >> temp.tmp
echo .
echo ** Running RSG3 on the RGB image files **
rsg3 < temp.tmp >> nul
echo .
echo ** Running REDUCE to produce the composite image **
reduce %4 /c %6 /m %7
echo .
echo ** Deleting temporary files **
del ered.img
del egreen.img
del eblue.img
del %4.cmg
del temp.tmp
del temp1.tmp
echo .
echo ** Done:  %4.lbl, %4.dat, %4.pal created **
:done
