@echo off
break on
echo .
if exist %1.%2 goto begin
echo Procedure CSR produces a color shaded relief image for viewing by
echo program IMVIS.
echo .
echo USAGE:  csr P1 P2 P3 P4 P5 P6 P7 P8 P9
echo .
echo P1 = file name prefix of input grid for shading
echo P2 = file name suffix of input grid for shading
echo P3 = desired average slope of shading grid
echo P4 = complete file name of input grid for coloring
echo P5 = output image name
echo P6 = sun altitude in degrees above the horizon
echo P7 = sun azimuth in degrees clockwise from north
echo P8 = number of colors in the output image
echo P9 = minimum number of pixels assigned to one color
echo .
echo EXAMPLE:  csr test grd 10 test.grd shade 60 -45 240 5
echo .
goto done
:begin
echo . > temp.tmp
for %%f in (%1.n1 %1.n2) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%1.n3 %1.shd) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%5.cmg %5.lbl) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%5.dat %5.pal) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%1.n1 %1.n2) do if exist %%f if exist temp.tmp del temp.tmp
for %%f in (%1.n3 %1.shd) do if exist %%f if exist temp.tmp del temp.tmp
for %%f in (%5.cmg %5.lbl) do if exist %%f if exist temp.tmp del temp.tmp
for %%f in (%5.dat %5.pal) do if exist %%f if exist temp.tmp del temp.tmp
if not exist temp.tmp echo .
if not exist temp.tmp echo Hit Ctrl-Break to exit, otherwise...
if not exist temp.tmp pause
if exist %1.n1 del %1.n1
if exist %1.n2 del %1.n2
if exist %1.n3 del %1.n3
echo %1.%2 > temp.tmp
echo %1.n1 >> temp.tmp
echo %1.n2 >> temp.tmp
echo %1.n3 >> temp.tmp
echo %3 >> temp.tmp
echo .
echo ** Running NORMAL on the shading grid **
normal < temp.tmp >> nul
echo %1.n1 > temp.tmp
echo %1.n2 >> temp.tmp
echo %1.n3 >> temp.tmp
echo %1.shd >> temp.tmp
echo %6 %7 >> temp.tmp
echo .
echo ** Running SHADE on the normal vector grids **
shade < temp.tmp >> nul
del %1.n1
del %1.n2
del %1.n3
echo %4 > temp.tmp
echo csr.tmp >> temp.tmp
echo ** Running HISTNORM on the coloring grid **
histnorm < temp.tmp >> nul
rem goto done
echo csr.tmp > temp.tmp
echo .
echo ** Running RAINBOW on the stretched coloring grid **
rainbow < temp.tmp >> nul
del csr.tmp
echo %1.shd > temp.tmp
echo .
echo ** Running CSHADE to combine color and shade grids **
cshade < temp.tmp >> nul
del %1.shd
del red.grd
del green.grd
del blue.grd
if exist sred.img del sred.img
if exist sgreen.img del sgreen.img
if exist sblue.img del sblue.img
echo sred.grd > temp.tmp
echo sred.img >> temp.tmp
echo .
echo ** Running GRDREM on the red component **
grdrem < temp.tmp >> nul
del sred.grd
echo sgreen.grd > temp.tmp
echo sgreen.img >> temp.tmp
echo .
echo ** Running GRDREM on the green component **
grdrem < temp.tmp >> nul
del sgreen.grd
echo sblue.grd > temp.tmp
echo sblue.img >> temp.tmp
echo .
echo ** Running GRDREM on the blue component **
grdrem < temp.tmp >> nul
del sblue.grd
echo sred.img > temp.tmp
echo sgreen.img >> temp.tmp
echo sblue.img >> temp.tmp
echo %5.cmg >> temp.tmp
echo %4 > temp1.tmp
getdims < temp1.tmp >> temp.tmp
echo .
echo ** Running RSG3 on the RGB image files **
rsg3 < temp.tmp >> nul
del sred.img
del sgreen.img
del sblue.img
echo .
echo ** Running REDUCE to produce the composite image **
reduce %5 /c %8 /m 9
echo .
echo ** Deleting temporary files **
del %5.cmg
del temp.tmp
del temp1.tmp
echo .
echo ** Done:  %5.lbl, %5.dat, %5.pal created **
:done
