@echo off
echo .
if exist %1.%2 goto begin
echo This procedure terraces an input grid file that is
echo in USGS standard grid format.
echo .
echo USAGE: terrace P1 P2 P3
echo .
echo P1 is the input file name prefix
echo P2 is the input filename suffix
echo P3 is the number of iterations to be used
echo .
echo EXAMPLE: 
echo To terrace the grid file MYDATA.GRD with 20 iterations,
echo type: terrace MYDATA GRD 20
echo .
goto done
:begin
echo . > temp.tmp
for %%f in (%1.ter %1.fil) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%1.ter %1.fil) do if exist %%f if exist temp.tmp del temp.tmp
if not exist temp.tmp echo .
if not exist temp.tmp echo Hit Ctrl-Break to abort, otherwise . . .
if not exist temp.tmp pause
echo %1.%2 > temp.tmp
echo %1.tmp >> temp.tmp
echo gradient of %1.%2 >> temp.tmp
echo .
echo ** Running the gradient program **
gradient < temp.tmp >> nul
echo %1.tmp > temp.tmp
echo %1.ter >> temp.tmp
echo 0 >> temp.tmp
echo ** Running the stdbndy program **
stdbndy < temp.tmp >> nul
echo %1.%2 > temp.tmp
echo %1.ter >> temp.tmp
echo %1.tmp >> temp.tmp
echo ** Running the combgr program **
combgr < temp.tmp >> nul
echo %1.tmp > temp.tmp
echo %1.ter >> temp.tmp
echo %3 >> temp.tmp
echo terrace of %1.%2 with %3 iterations >> temp.tmp
echo ** Running the terrace4 program **
echo .
terrace4 < temp.tmp
echo %1.ter > temp.tmp
echo %1.tmp >> temp.tmp
echo 1 >> temp.tmp
echo transpose of %1.ter >> temp.tmp
echo ** Running the transpos program **
transpos < temp.tmp >> nul
echo %1.tmp > temp.tmp
echo %1.ter >> temp.tmp
echo ** Running the fixter program **
fixter < temp.tmp >> nul
echo %1.ter > temp.tmp
echo %1.tmp >> temp.tmp
echo 1 >> temp.tmp
echo transpose of %1.ter >> temp.tmp
echo ** Running the transpos program **
transpos < temp.tmp >> nul
echo %1.tmp > temp.tmp
echo %1.ter >> temp.tmp
echo ** Running the fixter program **
fixter < temp.tmp >> nul
echo %1.ter > temp.tmp
echo %1.tmp >> temp.tmp
echo ** Running the mediplg1 program **
mediplg1 < temp.tmp >> nul
echo %1.tmp > temp.tmp
echo %1.fil >> temp.tmp
echo 1 >> temp.tmp
echo ** Running the medifilt program **
medifilt < temp.tmp >> nul
echo ** Deleting temporary files
del %1.tmp
del temp.tmp
echo .
echo ** Done:  %1.ter, %1.fil created **
:done

