c  Program DETOUR
c
c  Contouring of scattered data using Delaunay tessellation
c
c  modified from  D.F. Watson by J. Phillips
c
c  reference: Watson, D.F., 1982, Acord: Automatic contouring of raw data:
c             Computers and Geosciences, v.8, no. 1, p.97-101.
c
      parameter (maxpst=52)
      dimension xyz(1203,3), tetr(2401,3), xpnt(3,3), det(2,3)
      dimension isl(5), dxp(2), dyp(2), xp(4), yp(4), x(2), y(2),
     +          ie(10), ipn(12), post(6)
      integer itetr(2401,3), istack(2401), ktetr(1024,2), itemp(3,2)
      character ifile*80, tri*1, dat*1, lab*8, label*9
        logical    binary, expres
      data itemp,xpnt/1,1,2,2,3,3,-1.,5.,-1.,-1.,-1.,5.,2.,2.,18./
      data ipn/100,900,300,1100,200,1000,1400,600,400,1200,500,1300/
      data abit1/0.5/
      print *,'input post or xyz file name: '
      read(5,100) ifile
  100 format(a)
        call openf(10,ifile,istack,maxpst,binary,expres,
     1        nword,maxlog,ntotal)
c  set function switches
        ifunc = 0
	if ( binary  .and.  nword .gt. 3 ) then
	  ifunc = 2
	endif
	if ( binary  .and.  nword .eq. 3 ) then
	  ifunc = 3
	endif
        if ( expres ) ifunc = 1
      if(ifunc.eq.2) then
        print *,'enter z-field (1 to 6):'
        read(5,*) iz
      endif
      print *,'enter iplotr (5=HP,8=CGA,9=EGA,10=VGA):'
      read(5,*) iplotr
      do 1 i=1,3
      itetr(1,i)=i
      tetr(1,i)=xpnt(i,3)
      do 1 j=1,3
    1 xyz(i,j)=xpnt(i,j)
      do 2 i=2,2401
    2 istack(i)=i
      size=1.0
c  read the data
      if(ifunc.eq.2) then
        read(10) lab,xyz(4,1),xyz(4,2),post
        xyz(4,3)=post(iz)
      else if(ifunc.eq.3) then
        read(10) xyz(4,1),xyz(4,2),xyz(4,3)
      endif
      xmin=xyz(4,1)
      xmax=xyz(4,1)
      ymin=xyz(4,2)
      ymax=xyz(4,2)
      zmin=xyz(4,3)
      zmax=xyz(4,3)
      do 3 i=5,1203
      if(ifunc.eq.2) then
        read(10,end=4) lab,xyz(i,1),xyz(i,2),post
        xyz(i,3)=post(iz)
      else if(ifunc.eq.3) then
        read(10,end=4) xyz(i,1),xyz(i,2),xyz(i,3)
      endif
      if(xyz(i,1).lt.xmin) xmin=xyz(i,1)
      if(xyz(i,1).gt.xmax) xmax=xyz(i,1)
      if(xyz(i,2).lt.ymin) ymin=xyz(i,2)
      if(xyz(i,2).gt.ymax) ymax=xyz(i,2)
      if(xyz(i,3).lt.zmin) zmin=xyz(i,3)
      if(xyz(i,3).gt.zmax) zmax=xyz(i,3)
    3 continue
      print *,'WARNING - input file may contain more than 1200 points'
    4 n=i-1
      print *,'xmin = ',xmin,' xmax = ',xmax
      print *,'ymin = ',ymin,' ymax = ',ymax
      print *,'zmin = ',zmin,' zmax = ',zmax
      print *, 'enter contour interval:'
      read(5,*) conti
      contm=zmin-amod(zmin,conti)+conti
      print *,'minimum contour level = ',contm
      lc=int((zmax-contm)/conti)
      print *,'number of contours = ',lc
      print *
      print *,'Press ENTER to continue'
      read(5,100) tri
c      print *,'plot triangles (y or n)?:'
c      read(5,100) tri
c      print *,'plot data (y or n)?:'
c      read(5,100) dat
      xr=xmax-xmin
      datax=xr
      yr=ymax-ymin
      if(yr.gt.datax) datax=yr
c  normalize the data
      do 5 i=4,n
      xyz(i,1)=(xyz(i,1)-xmin)/datax
    5 xyz(i,2)=(xyz(i,2)-ymin)/datax
      isp=1
      id=2
      do 13 nuc=4,n
      km=0
c  loop thru the established 3-tuples
      do 10 jt=1,isp
c  test if new data point is within the jt circumcircle
      dsq=tetr(jt,3)-(xyz(nuc,1)-tetr(jt,1))**2
      if(dsq.lt.0.0) go to 10
      dsq=dsq-(xyz(nuc,2)-tetr(jt,2))**2
      if(dsq.lt.0.0) go to 10
c  delete this 2-tuple but save its edges
      id=id-1
      if(id.lt.1) id=1
      istack(id)=jt
c  add edges to ktetr but delete if already listed
      do 9 i=1,3
      l1=itemp(i,1)
      l2=itemp(i,2)
      if(km.le.0) go to 8
      kmt=km
      do 7 j=1,kmt
      if(itetr(jt,l1).ne.ktetr(j,1)) go to 7
      if(itetr(jt,l2).ne.ktetr(j,2)) go to 7
      km=km-1
      if(j.gt.km) go to 9
      do 6 k=j,km
      k1=k+1
      do 6 l=1,2
    6 ktetr(k,l)=ktetr(k1,l)
      go to 9
    7 continue
    8 km=km+1
      if(km.gt.1024) stop 'increase ktetr array dimension'
      ktetr(km,1)=itetr(jt,l1)
      ktetr(km,2)=itetr(jt,l2)
    9 continue
   10 continue
c  form new 3-tuples
      do 12 i=1,km
      kt = istack(id)
      id = id + 1
c  calculate the circumcircle center and radius
c  squared of points ktetr(i,*) and place in tetr(kt,*)
      do 11 jz = 1,2
      i2 = ktetr(i,jz)
      det(jz,1) = xyz(i2,1) - xyz(nuc,1)
      det(jz,2) = xyz(i2,2) - xyz(nuc,2)
   11 det(jz,3) = det(jz,1) * (xyz(i2,1) + xyz(nuc,1))/2.0
     +          + det(jz,2) * (xyz(i2,2) + xyz(nuc,2))/2.0
      dd = det(1,1) * det(2,2) - det(1,2) * det(2,1)
      if(abs(dd).lt.1.e-10) then
        print *,'Warning: dd = ',dd
        print *,'Data points ',i2-3,' and ',nuc-3,' may be duplicates.'
      endif
      if(dd.eq.0.0) go to 13
      tetr(kt,1) = (det(1,3) * det(2,2) - det(2,3) * det(1,2))/dd
      tetr(kt,2) = (det(1,1) * det(2,3) - det(2,1) * det(1,3))/dd
      tetr(kt,3) = (xyz(nuc,1) - tetr(kt,1))**2
     +           + (xyz(nuc,2) - tetr(kt,2))**2
      itetr(kt,1) = ktetr(i,1)
      itetr(kt,2) = ktetr(i,2)
   12 itetr(kt,3) = nuc
   13 isp = isp + 2
      call pltset(iplotr,xboard,yboard,isl)
      dxp(1)=0.0
      dxp(2)=xr/datax
      dyp(1)=0.0
      dyp(2)=yr/datax
      yp(1)=yboard-0.7
      xp(1)=yp(1)*xr/yr
      if(xp(1).gt.xboard-1.2) then
        xp(1)=xboard-1.2
        yp(1)=xp(1)*yr/xr
      endif
      xp(2)=0
      xp(3)=0.1
      xp(4)=xboard
      yp(2)=0
      yp(3)=0.6
      yp(4)=yboard
      nopts=4
      call scale(dxp,dyp,xp,yp,nopts,ier)
      if(ier.ne.0) stop 'could not scale the plot'
      call neatl
      call vchar(.15,.35,ifile,80,3,.1,0.,0.,0.)
      if(ifunc.eq.2) then
        ifile='z-field = '//char(iz+48)
        x=xp(3)+xp(1)-1.05
        call vchar(x,.35,ifile,11,3,.1,0.,0.,0.)
      endif
      do 19 jt = 1,isp
      if(itetr(jt,1) .lt. 4 .or. tetr(jt,3) .gt. 1.) go to 19
c  find contour intersections
      abit = 0.0
      if(xyz(itetr(jt,1),3) .eq. xyz(itetr(jt,2),3) .or.
     +   xyz(itetr(jt,1),3) .eq. xyz(itetr(jt,3),3) .or.
     +   xyz(itetr(jt,2),3) .eq. xyz(itetr(jt,3),3)) abit = abit1
      top = amax1(xyz(itetr(jt,1),3),xyz(itetr(jt,2),3),
     +            xyz(itetr(jt,3),3))
      bot = amin1(xyz(itetr(jt,1),3),xyz(itetr(jt,2),3),
     +            xyz(itetr(jt,3),3))
      do 18 jc =  1,lc
      cont=contm+(jc-1)*conti
      ip=1+jc*12/(lc+1)
      jp=1+jc*8/(lc+1)
      if(cont .gt. top .or.  cont .lt. bot) go to 18
      cz = (cont - xyz(itetr(jt,1),3))/(xyz(itetr(jt,2),3)
     +           - xyz(itetr(jt,1),3) + abit)
      if(cz .le. 0.0 .or. cz .ge. 1.0) go to 15
      x1 = (xyz(itetr(jt,1),1) + (xyz(itetr(jt,2),1)
     +   -  xyz(itetr(jt,1),1)) * cz) * size
      y1 = (xyz(itetr(jt,1),2) + (xyz(itetr(jt,2),2)
     +   -  xyz(itetr(jt,1),2)) * cz) * size
   14 cz = (cont - xyz(itetr(jt,1),3))/(xyz(itetr(jt,3),3)
     +           - xyz(itetr(jt,1),3) + abit)
      if(cz .lt. 0.0 .or. cz .gt. 1.0) go to 16
      x2 = (xyz(itetr(jt,1),1) + (xyz(itetr(jt,3),1)
     +   -  xyz(itetr(jt,1),1)) * cz) * size
      y2 = (xyz(itetr(jt,1),2) + (xyz(itetr(jt,3),2)
     +   -  xyz(itetr(jt,1),2)) * cz) * size
      go to 17
   15 cz = (cont - xyz(itetr(jt,1),3))/(xyz(itetr(jt,3),3)
     +           - xyz(itetr(jt,1),3) + abit)
      if(cz .lt. 0.0 .or. cz .gt. 1.0) go to 18
      x1 = (xyz(itetr(jt,1),1) + (xyz(itetr(jt,3),1)
     +   -  xyz(itetr(jt,1),1)) * cz) * size
      y1 = (xyz(itetr(jt,1),2) + (xyz(itetr(jt,3),2)
     +   -  xyz(itetr(jt,1),2)) * cz) * size
   16 cz = (cont - xyz(itetr(jt,2),3))/(xyz(itetr(jt,3),3)
     +           - xyz(itetr(jt,2),3) + abit)
      if(cz .lt. 0.0 .or. cz .gt. 1.0) go to 18
      x2 = (xyz(itetr(jt,2),1) + (xyz(itetr(jt,3),1)
     +   -  xyz(itetr(jt,2),1)) * cz) * size
      y2 = (xyz(itetr(jt,2),2) + (xyz(itetr(jt,3),2)
     +   -  xyz(itetr(jt,2),2)) * cz) * size
   17 continue
      x(1)=x1
      x(2)=x2
      y(1)=y1
      y(2)=y2
      if(iplotr.eq.5) call newpen(jp)
      call line(x,y,2,0,ipn(ip))
   18 continue
c      if(tri.eq.'n') go to 19
c      x(1)=xyz(itetr(jt,1),1)
c      x(2)=xyz(itetr(jt,2),1)
c      y(1)=xyz(itetr(jt,1),2)
c      y(2)=xyz(itetr(jt,2),2)
c      call line(x,y,2,0,801)
c      x(1)=xyz(itetr(jt,1),1)
c      x(2)=xyz(itetr(jt,3),1)
c      y(1)=xyz(itetr(jt,1),2)
c      y(2)=xyz(itetr(jt,3),2)
c      call line(x,y,2,0,801)
c      x(1)=xyz(itetr(jt,2),1)
c      x(2)=xyz(itetr(jt,3),1)
c      y(1)=xyz(itetr(jt,2),2)
c      y(2)=xyz(itetr(jt,3),2)
c      call line(x,y,2,0,801)
   19 continue
c      if(dat.eq.'n') go to 21
      do 20 i=4,n
      call vchar(xyz(i,1),xyz(i,2),13,1,1500,.1,0.,0.,0.)
   20 continue
c plot scale
      ipold=0
      y=.3
      do 22 i=1,lc
      ip=1+i*12/(lc+1)
      jp=1+i*8/(lc+1)
      cont=contm+(i-1)*conti
      if(ip.ne.ipold) then
      write(label(1:9),'(g9.3)') cont
      y=y+.4
      if(iplotr.eq.5) call newpen(jp)
      call vchar(xp(1)+0.4,y,label,9,ipn(ip)+3,.1,0.,0.,0.)
      endif
      ipold=ip
   22 continue
   21 call endpt(ie)
      stop
      end
c*******************************************************************************
      subroutine openf( iswt, ifile, ibuff, maxpst, binary, expres,
     1                 nword, maxlog, ntotal )

c  open data file, derive and checkout file structure.
c
c  input file types:
c  xyz      single record xyz data.
c  post     single record containing an id (8 characters), x, y, and
c           1-n dependant-variable channels. Normally n=6, but this
c           program accepts more channels.
c
c  Note: express file options deleted for PC version 1 series.

	parameter  ( maxbuf=1024 )
      dimension  ibuff(maxbuf)
	character  ifile*(*)
	logical    binary, expres
	nword  = 0
	maxlog = 0
	ntotal = 0
	binary = .false.
	expres = .false.

c  open binary
	open( unit=iswt, file=ifile, status='old', form='unformatted',
     1     mode='read', iostat=ios )
	if ( ios .ne. 0 ) then
        print *,' error opening input data file ( cannot find )'
	  stop
	endif

c  binary or ascii input ?
	read( iswt, err=10, iostat=ios ) itest
10	rewind( iswt )
	if ( ios .eq. 0 ) then
	  binary = .true. 
	  else
	  close( iswt ) 
	  go to 100
	endif

c  file is binary
c  lenrec returns zero if buffer is too short
      nword = lenrec( iswt, ibuff, maxpst )
	if ( nword .eq. 1  .or.  nword .eq. 2 ) go to 200

c  simple xyz file.
	if ( nword .eq. 3 ) then
        print *, ' binary xyz data'
	  go to 999
	endif

c  simple post file.
	if ( nword .ge. 4   .and.   nword .le. maxpst ) then
        nchan  = nword - 2
        nnchan=nchan-2
        print *, ' post data,  found', nnchan, ' data channels'
	  go to 999
	endif


c  open for ascii input
100	  open( unit=iswt, file=ifile, status='old', form='formatted', 
     1       mode='read' )
	go to 999

c  record length undefined.
200   print *, ' input record length =', nword
      print *, ' input is neither xyz or post'

999	return
        end
c******************************************************************************
	function lenrec( iswt, irec, nwork )
c  brute force recovery of record length
	dimension irec(nwork)

	istep = 10
	if ( nwork .gt. 100 ) istep = 20
	if ( nwork .gt. 500 ) istep = 50
	rewind iswt

	do max = istep, nwork, istep
	  read( iswt, err=10 ) ( irec(i), i=1, max )
	  rewind iswt
	enddo
	lenrec = -1
	go to 99

10	rewind iswt
	do lenrec = max, max - istep, -1
	  read( iswt, err=20 ) ( irec(i), i=1, lenrec )
	  go to 99
20	  rewind iswt
	enddo

99	rewind iswt
	return
        end
c******************************************************************************
         subroutine newpen(ipensel)
c
c       written by cindy cooper, january 4, 1982.
c
c       this subroutine is used to select a pen
c       for the hp7580a.  ipensel is the number of
c       pen to be selected.  if ipltr is not equal
c       to the hp7580a, no action is taken.
c
c      include 'pxz99.cmn'
c
c       make sure plot buffer is empty
c        call hpform
c        nxyrs=0
c
c       command the hp7580 to pick up the desired pen,
c       then prepare again for absolute plotting.
c        if (ipltr .eq. 6) then
                write (20,100) ipensel
100             format(' SP',i1,';')
c        endif
        return
        end
