c  utility.for
c
c             2-d grid utility program
c
c  format:
c  header record contains:
c    56 charater title, ( 14 * 4 character words)
c     8 character creation program or operation identifier
c    number of columns,  the number of words in a row record minus one
c    number of rows,     the number of records after the header.
c    number of z values associated with each grid point ( always one ).
c    xo,  coordinate (in real data units ) along profile of the rows.
c    dx   spacing    (d.u.) along a row.
c    yo   coordinate (d.u.) for the transverse position of a row.
c    dy   spacing    (d.u.) of the rows.

c   followed by row records consisting of a y coordinate (unused if
c   dely is nonzero) and grid value array ncolumns in length.
c
c     Mike Webring, USGS, branch of geophysics
c     Converted to PC with minor changes by Lin Cordell Aug 90
c     The plug option doesn't work and has been disabled, use MEGAPLUG
c
	common /work/ z(2000), zs(2000), spare(26000)
	common /ogrid/ jf, iproj, cmerid, baslat
	dimension ndx(50)
	character*56 id, id2, if, jf, kf, idnew, info, blank
	character ians*1, ifunc*20, p*8, p2*8, pgmnew*8
      data nwork/30000/, dv/0.170412e+39/,
     1    itty,idv,jdv,kdv,ldv/5,12,13,14,15/
	dval  = dv
	big   = 1.e29
	blank = ' '
c
1     print  5
5	format(/,' function :'$)
      read( itty, 10, end=1, err=1 ) ifunc
      if(ifunc.eq.'help')ifunc='zilch'
10	format(a20)
	call cvc( ifunc, 2 )
	ians = ifunc(1:1)
      if ( ians .eq. 's' ) stop
      if(ians.eq.'p')then
        print*,'The plug option is disabled; use program MEGAPLUG'
        go to 1
      endif
20	if(ians.eq.'x' .or. ians.eq.'m' .or. ians.eq.'e' .or.
     1  ians.eq.'h' .or. ians.eq.'c' .or. ians.eq.'l' .or.
     1  ians.eq.'r') go to 30
      if(ians.eq.'p')print*,'The plug option is disabled; use MEGAPLUG'
      print  25
25	format(' available operations',/,
     1 ' r reorder elements',/,
     1 ' x extract subset',/,
     1 ' l look at grid values',/,
     1 ' h change header info',/,
     1 ' e edit grid points',/,
     1 ' m merge subset- xo,yo in number of cols,rows offset',/,
     1 ' c binary xyz coordinate output',/,
     1 ' s stop')
	go to 1
c
30    print  35
35	format( ' input grid :'$ )
	read(itty,37) if
37	format( a56 )
	open( unit=idv, file=if, form='unformatted', status='old',
     1     iostat=ios, mode='read' )
	if ( ios .ne. 0 ) then
        print *, ' could not open grid, please reenter filename'
	  go to 30
	endif
	call rdhdr( idv, id, p, nc,nr,nz, xo,dx,yo,dy,
     1           iproj, baslat, cmerid )
c
	if ( ians .ne. 'l' ) then
c  open output grid
39      print  40
40	  format(' output grid :'$)
	  read( itty, 37 ) jf
	endif
	length = 26
	if ( nc + 1 .gt. length ) length = nc + 1
c
50    print 55, id, p, nz, nc, nr, xo, yo, dx, dy
55	format(' id=',a56, 'pgm=',a8/, ' nz=',i1,'  size= ',2i5,
     1 /,' xo,yo =', 1p2g14.7,'  dx&dy=',2g14.5)
	if ( iproj .ne. 0 ) then
        print *, ' projection # =', iproj
        print *, ' central meridian & base latitude =', cmerid, baslat
	endif
c
	if(ians.eq.'p') go to 100
	if(ians.eq.'m') go to 200
	if(ians.eq.'e') go to 300
	if(ians.eq.'h') go to 400
	if(ians.eq.'c') go to 500
	if(ians.eq.'l') go to 600
	if(ians.eq.'x') go to 700
	if(ians.eq.'r') go to 800
	go to 1
c
c  plug holes using minimum curvature
100	open( unit=jdv, file=jf, form='unformatted', status='new',
     1       recl=length )
	call utp( dval, itty, idv, jdv )
	go to 999
c
c  merge function, secondary must be a subset of the primary grid
200   print  201
201	format(' secondary filename :'$)
	read(itty,37) kf
      open(unit=kdv,file=kf,form='unformatted',status='old',mode='read')
	read(kdv) id2,p2,nc2,nr2,nz,xo2,dx2,yo2,dy2
	if(dx2.ne.dx) stop ' dx1 not= dx2'
	if(dy2.ne.dy) stop ' dy1 not= dy2'
c
	open( unit=jdv, file=jf, form='unformatted', status='new',
     1       recl=length )
	gx=(xo2-xo)
	gy=(yo2-yo)
	ix=1+int(gx/dx)
	iy=1+int(gy/dy)
	ix2=ix-1+nc2
	iy2=iy-1+nr2
	if(ix.le.0 .or. iy.le.0 .or. ix2.gt.nc .or. iy2.gt.nr) then
       print *,' secondary grid is not a subset of the primary grid'
       print *,' starting x,y index, ending x,y index'
       print *,ix,iy,ix2,iy2
	 go to 1
	endif
	gx2=amod(gx,dx)
	gy2=amod(gy,dy)
	if(gx2.gt.0.1 .and. gx2.lt.0.9) stop ' x direction not registered'
	if(gy2.gt.0.1 .and. gy2.lt.0.9) stop ' y direction not registered'
	ir=0
	write(jdv)id,p,nc,nr,nz,xo,dx,yo,dy
	if(iy.eq.1) go to 211
	do 210 i=1,iy-1
	call rowio(nc,z,-1,idv,jdv,iend)
	ir=ir+1
210	call rowio(nc,z,0,idv,jdv,iend)
211	do 220 i=1,nr2
	call rowio(nc,z,-1,idv,jdv,iend)
	ir=ir+1
	call rowio(nc2,zs,-1,kdv,kdv,iend)
	do 230 j=1,nc2
	k=ix-1+j
230	z(k)=zs(j)
220	call rowio(nc,z,0,idv,jdv,iend)
	if(ir.eq.nr) go to 299
	do 240 i=ir+1,nr
	call rowio(nc,z,-1,idv,jdv,iend)
	ir=ir+1
240	call rowio(nc,z,0,idv,jdv,iend)
299	close(kdv)
	go to 999
c
c  edit function
300	ir=0
	open( unit=jdv, file=jf, form='unformatted', status='new',
     1       recl=length )
	write(jdv) id, p, nc, nr, nz, xo, dx, yo, dy,
     1         iproj, cmerid, baslat
301   print  302
302	format(' row to edit :'$)
	read(5,*,err=301)jr
	if(jr.lt.0) go to 301
303	call rowio(nc,z,-1,idv,jdv,iend)
	ir=ir+1
	if(jr.le.ir .and. jr.le.nr) go to 309
	call rowio(nc,z,0,idv,jdv,iend)
	if(ir.ge.nr) go to 999
	go to 303
309   print  340,ir
340	format(' preview row',i5,' ?'$)
	if(noyes(ldum).eq.0) go to 310
345   print  341
341	format(' col:from to '$)
	read(itty,*,err=345) ib,ie
	if(ib.lt.0) go to 399
	if(ib.eq.0) go to 310
      print  332,(z(i),i=ib,ie)
	go to 345
310   print  311
311	format(' dval from,to,number of rows :')
	read(5,*,err=310)ib,ie,num
	if(ib.lt.0) go to 399
	if(ib.eq.0) go to 320
	if(num.eq.0) num=1
313	do 312 i=ib,ie
312	z(i)=dval
	if(num.le.1) go to 310
	call rowio(nc,z,0,idv,jdv,iend)
	call rowio(nc,z,-1,idv,jdv,iend)
	ir=ir+1
	num=num-1
	go to 313
320   print  321
321	format(' n,(col,z,i=1,n):')
	read(5,*,err=320)n,(ndx(i),zs(i),i=1,n)
	if(n.lt.0) go to 399
	if(n.eq.0) go to 330
	do 322 i=1,n
322	z(ndx(i))=zs(i)
	go to 320
330   print  331
331   format(' print row? :')
	if(noyes(ldum).eq.1) go to 345
332	format(1x,1p5e12.4)
399	call rowio(nc,z,0,idv,jdv,iend)
	go to 301
c
c  change header info
400	ios = 0
401   if ( ios .ne. 0 ) print *, ' error reading input'
      print *, ' enter a carriage_return to leave info the same.'
      print *, ' new title (enter ctl_z to make blank) :'
	info = ' '
	read( itty, 37, err=401, end=402, iostat=ios ) info
402	if ( ios .eq. 0 ) then
	  idnew = id
	  if ( info .ne. blank ) idnew = info
	  else	    	
	  idnew = ' '
	endif
c
      print *, ' new program identifier (ctl_z for blank):'
	info = ' '
	read( itty, 37, err=401, end=403, iostat=ios ) info
403	if ( ios .eq. 0 ) then
	  pgmnew = p
	  if ( info .ne. blank ) pgmnew = info(1:8)
	  else
	  pgmnew = ' '
	endif
c
c
      xonew = xo
      mode=2
      print *, ' enter new x origin [',xonew,']'
      call readif(ix,xonew,mode)
      if(mode.eq.4)go to 401
c
c
      yonew = yo
      mode=2
      print *, ' enter new y origin [',yonew,']'
      call readif(ix,yonew,mode)
      if(mode.eq.4)go to 401
c
      dxnew = dx
      mode=2
      print *, ' enter new x increment [',dxnew,']'
      call readif(ix,dxnew,mode)
      if(mode.eq.4)go to 401
c
c
      dynew = dy
      mode=2
      print *, ' enter new y increment [',dynew,']'
      call readif(ix,dynew,mode)
      if(mode.eq.4)go to 401
c
      open( unit=jdv, file=jf, form='unformatted', status='new',
     1       recl=length )
	nz = 1
	write( jdv ) idnew, pgmnew,  nc, nr, nz,
     1            xonew, dxnew, yonew, dynew,
     1            iproj, cmerid, baslat
	do j = 1, nr
	  call rowio( nc, z, 1, idv, jdv, iend )
	enddo
	go to 999
c
c  coordinate output
500	nxb=1
	nxe=nc
	nyb=1
	nye=nr
        open(unit=jdv,file=jf,form='unformatted',status='new')
      print  *,' output whole grid ?'
	if(noyes(ldum).eq.0) then
        print *,' xo,yo (data units), nc,nr'
	  read(itty,*,err=500) xo2,yo2,nc2,nr2
	  xo2=xo2 + dx*0.499
	  nxb=int((xo2-xo)/dx)+1
	  nxe=nxb+nc2-1
	  if(nxb.lt.1)  nxb=1
	  if(nxe.gt.nc) nxe=nc
	  yo2=yo2 + dy*0.499
	  nyb=int((yo2-yo)/dy)+1
	  nye=nyb+nr2-1
	  if(nyb.lt.1) nyb=1
	  if(nye.gt.nr) nye=nr
	endif
	if((nye-nyb).le.0 .or. (nxe-nxb).le.0) then
        print *,' specified nc or nr <1'
	  go to 500
	endif
c
	xo3=xo + dx*(nxb-1)
	yo3=yo + dy*(nyb-1)
	if(nyb.gt.1) then
	  do j=1,nyb-1
	  read(idv)
	  enddo
	endif
c
	y=yo3
	do 550 j=nyb,nye
	call rowio(nc,z,-1,idv,jdv,iend)
	if(iend.eq.1) then
        print  *,' eof while reading'
	  go to 999
	endif
	x=xo3
	do 540 i=nxb,nxe
	if(z(i).gt.1.e30) go to 540
	write(jdv) x,y,z(i)
540	x=x+dx
550	y=y+dy
	go to 999
c
c  look mode
600	ir=0
610   print  601
601	format(' row :'$)
	read(itty,*,err=610) jr
	if(jr.lt.ir) go to 699
	if(jr.eq.ir) go to 605
	if(jr.eq.ir+1) go to 603
	do 602 i=ir+1,jr-1
	read(idv,end=699)
602	ir=ir+1
603	call rowio(nc,z,-1,idv,jdv,iend)
	if(iend.eq.1) go to 699
	ir=ir+1
605   print  604
604	format(' col from,to '$)
	read(itty,*,err=605) ib,ie
	if(ib.eq.0) go to 610
	if(ib.eq.-1) go to 699
      print  332,(z(i),i=ib,ie)
	go to 605
699	close(idv)
	go to 1
c
700	maxcol = 4000
	call utx( dval, maxcol, z, itty, idv, jdv )
	go to 999
c
800	call utr( itty, idv, jdv, kdv, ldv )
c
999	close(idv)
	close(jdv)
	go to 1
	end
c***********************************************************************
	subroutine rdhdr( iunit, id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1                        iproj, baslat, cmerid )
	character id*56, pgm*8
c
	read( iunit, err=9 )  id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1                     iproj, baslat, cmerid
	return
c
9	rewind iunit
	read( iunit, err=99 ) id, pgm, nc,nr,nz, xo,dx,yo,dy
	iproj  = 0
	baslat = 999.
	cmerid = 999.
	return
c
99    print *, ' cannot read grid header'
	stop
	end
c***********************************************************************
	subroutine utx( dval, maxcol, z, itty, idv, jdv )
c  grid utility extract function
c  no restriction on output grid size or location (subject to maxcol)
	common /ogrid/ ofile, iproj, cmerid, baslat
	dimension      z(maxcol)
	character      ofile*56, id*56, pgm*8
	irow=0
	jrow=0
	rewind(idv)
	read(idv) id,pgm,nc,nr,nz,xo,dx,yo,dy
	go to 5
1     print *,' conversion error...'
c
5     print 10
10	format(' output grid title')
	read(itty,37) id
37	format(a56)
c
      print *,' >> new origin'
15    print *,' enter either 0 for integer starting location'
      print *,'           or 1 for lower-left coordinate'
	read(itty,*,err=15) iswt
	if(iswt.lt.0 .or. iswt.gt.1) go to 15
	if(iswt.eq.0) then
        print *,' enter starting column and row number'
        print *,' 1,1 is the the start of the parent grid'
        print *,' negative numbers ok'
	  read(itty,*,err=15) ix,iy
	else
        print *,' enter lower-left x,y coordinate in data units'
	  read(itty,*,err=15) xorig,yorig
	  gx=(xorig-xo)/dx
	  gy=(yorig-yo)/dy
	  ix=1+int(gx+sign(0.5,gx))
	  iy=1+int(gy+sign(0.5,gy))
	endif
	xo2=xo+dx*float(ix-1)
	yo2=yo+dy*float(iy-1)
c
      print *,' >> output size'
20    print *,' enter either 0 for ending column and row number'
      print *,'           or 1 for upper-right coordinate'
      print *,'           or 2 for specified ncol, nrow'
	read(itty,*,err=20) iswt
	if(iswt.lt.0 .or. iswt.gt.2) go to 20
	if(iswt.eq.2) then
        print *,' enter new dimensions (integer ncol,nrow)'
	  read(itty,*,err=20) nc2,nr2
	else if(iswt.eq.1) then
        print *,' enter upper-right x,y coordinate in data units'
	  read(itty,*,err=20) xe2,ye2
	  nc2=1+int(0.5+(xe2-xo2)/dx)
	  nr2=1+int(0.5+(ye2-yo2)/dy)
	else
        print *,' enter ending column and row number in the parent grid'
	  read(itty,*,err=20) ixe,iye
	  xe2=xo+dx*float(ixe-1)
	  ye2=yo+dy*float(iye-1)
	  nc2=1+int(0.5+(xe2-xo2)/dx)
	  nr2=1+int(0.5+(ye2-yo2)/dy)
	endif
	if(nc2.le.0 .or. nr2.le.0) go to 20
c
      print *,' output grid ncol,nrow will be ', nc2, nr2
	length = 26
	if ( nc2 + 1 .gt. length ) length = nc2 + 1
	open( unit=jdv, file=ofile, status='new', form='unformatted',
     1     recl=length )
c
c  ix1,ix2 are starting addresses for the input and output rows
	if(ix.gt.0) then
	  ix1=1
	  ix2=ix
	else
	  ix1=2-ix
	  ix2=1
	endif
	ic =ix1+nc-1
	ic2=ix2+nc2-1
	if(ic2.gt.ic) ic=ic2
	if(ic.gt.maxcol) then
        print *,maxcol,' column temp storage exceeded'
	  return
	else
	  do 50 i=1,ic
50	  z(i)=dval
	endif
c
	write(jdv) id, pgm,  nc2, nr2, nz,  xo2, dx, yo2, dy,
     1          iproj, cmerid, baslat
c
	if ( iy .eq. 1 ) go to 90
c  starting condition
	if(iy.le.0) then
	  do 70 i=iy,0
	  call rowio(nc2,z(ix2),0,idv,jdv,ie)
	  jrow=jrow+1
	  if(jrow.ge.nr2) go to 200
70	  continue
	else
	  do 80 i=1,iy-1
	  read(idv,end=120)
	  irow=irow+1
        if(irow.ge.nr) go to 120
80	  continue
	endif
c
c  transfer grid1 to grid2
90	input=1
100	if(jrow.ge.nr2) go to 200
	go to (110,150) input
110	call rowio(nc,z(ix1),-1,idv,jdv,iend)
	irow=irow+1
120	if(irow.gt.nr .or. iend.eq.1) then
	  input=2
	  do 130 i=1,ic
130	  z(i)=dval
	  endif
150	call rowio(nc2,z(ix2),0,idv,jdv,jend)
	jrow=jrow+1
	if(input.eq.2) go to 100
	y1=yo+ dy*float(irow-1)
	y2=yo2+dy*float(jrow-1)
	ychk=2.0*abs(y2-y1)
	if(ychk.gt.dy .and. irow.lt.nr)
     1 print *,' utx: y error irow,jrow,yi,yj =',irow,jrow,y1,y2
	go to 100
200	return
	end
c***********************************************************************
	subroutine utr( itty, isw, jsw, ksw, lsw )
c  grid reordering function
	common /work/  buf(30000)
	common /ogrid/ ofile, iproj, cmerid, baslat
	character ofile*56, p*8, p2*8, id*56, id2*56, blank*56
	data nbuf/ 30000 /
	blank = ' '
c
	rewind isw
	read(isw) id, p, nc, nr, nz, xo, dx, yo, dy
	x2  = float( nc - 1 ) * dx + xo
	y2  = float( nr - 1 ) * dy + yo
	dx2 = -dx
	dy2 = -dy
c
      print *, 'title'
      read(5,37) id2
37	format(a)
	if ( id2 .eq. blank ) id2 = id
      print  15
15	format(' enter 1 for transpose',/,
     1      '       2 for column reverse',/,
     1      '       3 for row    reverse',/,
     1      '       4 for 90  deg counter-clockwise rotation',/,
     1      '       5 for 90  degree      clockwise rotation ',/,
     1      '       6 for 180 degree rotation')
1	iop = 0
	read( itty, *, err=2, end=2 ) iop
2	if ( iop .lt. 1 .or. iop .gt. 6 ) then
        print *, iop, ' not recognized'
	  go to 1
	endif
c
	length = 26
	if ( iop.eq.1 .or. iop.eq.4 .or. iop.eq.5 ) then
c  flip col and rows, record length = nr + 1
	  if ( nr + 1 .gt. length ) length = nr + 1
	  else
	  if ( nc + 1 .gt. length ) length = nc + 1
	endif
	open( unit=jsw, file=ofile, status='new', form='unformatted',
     1     recl=length )
c	
	if ( iop .eq. 1 ) then
c  transpose
	p2 = 'transpos'
	write(jsw) id2, p2, nr, nc, nz, yo, dy, xo, dx,
     1          iproj, cmerid, baslat
	call xpose( nc, nr, buf, nbuf, isw, jsw, ksw )
	go to 999
	endif
c
	if ( iop .eq. 2 ) then
c  reverse columns
	p2 = 'rev_col'
	write(jsw) id2, p2, nc, nr, nz, x2, dx2, yo, dy,
     1          iproj, cmerid, baslat
	call revcol( nc, nr, buf, isw, jsw )
	go to 999
	endif
c
c  reverse rows
	if ( iop .eq. 3 ) then
	p2 = 'rev_row'
	write(jsw) id2, p2, nc, nr, nz, xo, dx, y2, dy2,
     1          iproj, cmerid, baslat
	call revrow( nc, nr, buf, isw, jsw, ksw )
	go to 999
	endif
c
c  rotate 90 degree counter-clockwise
	if ( iop .eq. 4 ) then
      open( unit=lsw, status='scratch',
     1     form='unformatted' )
	write( lsw ) id2, p2, nr, nc, nz, yo, dy, xo, dx
	call xpose( nc, nr, buf, nbuf, isw, lsw, ksw )
c
	p2 = '-90clock'
	write( jsw ) id2, p2, nr, nc, nz, y2, dy2, xo, dx,

     1            iproj, cmerid, baslat
	call revcol( nr, nc, buf, lsw, jsw )
	close( lsw )
	go to 999
	endif
c
c  rotate 90 degree clockwise
	if ( iop .eq. 5 ) then
      open( unit=lsw, status='scratch',
     1     form='unformatted' )
	p2 = 'rev-col'	
	write(lsw) id2, p2, nc, nr, nz, x2, dx2, yo, dy
	call revcol( nc, nr, buf, isw, lsw)
c
	p2 = '+90clock'
	write(jsw) id2, p2, nr, nc, nz, yo, dy, x2, dx2,
     1          iproj, cmerid, baslat
	call xpose( nc, nr, buf, nbuf, lsw, jsw, ksw )
	close( lsw )
	go to 999
	endif
c
c  rotate 180 degree
	if ( iop .eq. 6 ) then
      open( unit=lsw, status='scratch',
     1     form='unformatted' )
	p2 = 'rev-col'	
	write( lsw ) id2, p2, nc, nr, nz, x2, dx2, yo, dy
	call revcol( nc, nr, buf, isw, lsw)
c
	p2 = '180clock'
	write( jsw ) id2, p2, nc, nr, nz, x2, dx2, y2, dy2,
     1            iproj, cmerid, baslat
	call revrow( nc, nr, buf, lsw, jsw, ksw )
	close( lsw )
	endif
c
999	return
	end
c***********************************************************************
	subroutine xpose( nc, nr, buf, nbuf, isw, jsw, ksw )
c  transpose using a random access file
	dimension buf(nbuf)
	if ( nc .gt. nbuf / 20 ) stop ' 20 * ncol > nbuf'
	if ( nr .gt. nbuf / 20 ) stop ' 20 * nrow > nbuf'
      open( ksw, status='scratch',
     1     form='unformatted', access='direct', recl=1600 )
	m   = 1 + ( nc - 1 ) / 20
	n   = 1 + ( nr - 1 ) / 20
	n20 = 20 * n
	m20 = 20 * m
	call rio( buf, m, n, 1, 1, m20, -1, isw, ksw )
	ic = 1
c
	do 100 ibuf = 1, m
	loc = ibuf
	call rio( buf, n, 0, loc, m, n20, 1, isw, ksw )
c
	ndex = 1
	do irow = 1, 20
	  call rowio (nr, buf(ndex), 0, jsw, jsw, iend )
	  if ( ic .eq. nc ) go to 999
	  ic   = ic   + 1
	  ndex = ndex + n20
	enddo
100	continue
c
999	close(ksw)
	return
	end
c***********************************************************************
	subroutine revcol( nc, nr, z, isw, jsw )
	dimension ihdr(16), z(nc)
	rewind(isw)
	read(isw) ihdr, nc1, nr1
	if ( nc1 .ne. nc  .or.  nr1 .ne. nr ) then
        print *, ' passed dimensions (ncol, nrow):', nc, nr
        print *, ' header dimensions             :', nc1, nr1
	  stop
	endif
	do j = 1, nr
	  read( isw, end=10, iostat=ios ) xx, z
10	  if ( ios .ne. 0 ) then
          print *, ' premature EOF at row', j
	    return
	  endif
	  i2 = nc
	  do i = 1, nc / 2
	    tmp   = z(i2)
	    z(i2) = z(i)
	    z(i)  = tmp
	    i2    = i2 - 1
	  enddo
	  write( jsw ) xx, z
	enddo
	return
	end
c***********************************************************************
	subroutine revrow( nc, nr, z, isw, jsw, ksw )
	dimension z(nc)
      open( ksw, status='scratch',
     1     form='unformatted', access='direct', recl=4*(nc+1) )
	rewind(isw)
	read(isw)
	do j = 1, nr
	  read(isw) xx, z
	  write(ksw,rec=j) xx, z
	enddo
	j2 = nr
	do j = 1, nr
	  read(ksw,rec=j2) xx, z
	  write(jsw) xx, z
	  j2 = j2 - 1
	enddo
	close(ksw)
	return
	end
c***********************************************************************
	subroutine rio(z,nblk,nbuf,loc2,idloc,lenz,iop,isw,ksw)
c iop=-1 read grid, pad with dval's, and output with implied iop=1
c    =0 output 20x20 tranposed blocks
c    =1 input  20x20 block
c buffer z is dimensioned lenz x 20
c random access is nblk x nbuf, where 'loc' increments by 'idl'
	dimension hdr(16),w(400),z(1)
	logical more
      data dval/0.170412e+39/
	loc=loc2
	assign 999 to iret
c
	if(iop)1,2,3
1	assign 99 to iret
	more=.true.
	itot=0
	rewind(isw)
	read(isw) hdr,nc,nr,nz,xo,dx,yo,dy
	do 100 ibuf=1,nbuf
	do i=1,lenz*20
	  z(i)=dval
	enddo
	ireadz=1
	do irow=1,20
	  if(more) then
	    call rowio(nc,z(ireadz),-1,isw,isw,iend)
	    ireadz=ireadz+lenz
	    if(iend.eq.0) itot=itot+1
	    if(iend.ne.0 .or. itot.ge.nr) more=.false.
	  endif
	enddo
	  go to 2
99	  continue
100	continue
      if(itot.ne.nr) print *,' found only ',itot,' of ',nr,' rows'
	return
c
c  extract 20x20 block, tranpose, and output
2	do iblk=1,nblk
	iws=1
	izs=(iblk-1)*20+1
	do j=1,20
	  iw=iws
	  iz=izs
	  do i=1,20
	    w(iw)=z(iz)
	    iw=iw+20
	    iz=iz+1
	  enddo
	  iws=iws+1
	  izs=izs+lenz
	enddo
      write(ksw,rec=loc) w
	loc=loc+idloc
	enddo
	go to iret,(99,999)
c
c  insert 20x20 block into buffer
3	do iblk=1,nblk
      read(ksw,rec=loc) w
	iw=1
	izs=(iblk-1)*20+1
	do j=1,20
	  iz=izs
	  do i=1,20
	    z(iz)=w(iw)
	    iw=iw+1
	    iz=iz+1
	  enddo
	izs=izs+lenz
	enddo
	loc=loc+idloc
	enddo
c
999	return
	end
c***********************************************************************
	subroutine utp( dval, itty, idv, jdv )
c  plug holes using minimum curvature interpolation
c  gridr and curvmn are from the minc program, usgs open file 81-1224
	common /work/ zg(14750), iqd(14750), wz(500)
	character id*56, p*8, p2*8
	data nwrk/14750/, p2/'m-c plug'/
	rewind idv
	read(idv) id,p,nc,nr,nz,xo,dx,yo,dy
	nn=nc*nr
	if(nn.gt.nwrk) then
        print *,' ncol*nrow >',nwrk
	  return
	endif
1     print 2
2	format(' number of minimum curvature iterations to use :'$)
	read(itty,*,err=1) nim
	do 5 i=1,nn
5	iqd(i)=-1
	ndx=1
	do 20 j=1,nr
	call rowio(nc,zg(ndx),-1,idv,jdv,ie)
	i2=ndx
	do 10 i=1,nc
	if(zg(i2).gt.1.e29) then
	  zg(i2)=dval
	  iqd(i2)=0
	endif
10	i2=i2+1
	if(ie.eq.1) go to 99
20	ndx=ndx+nc
c
      call gridr( nc, nr, zg, wz, dval, ier )
	if(ier.eq.1) then
        print *,' gridr: initialization error'
	  return
	endif
	if(nim.eq.0) go to 30
	eps=0.
	call curvmn(zg,iqd,wz,nc,nr,eps,nim,a,b,ni)
      print*,'OK SO FAR NO 2'
30	write(jdv)id,p2,nc,nr,nz,xo,dx,yo,dy
	ndx=1
	do 50 i=1,nr
	call rowio(nc,zg(ndx),0,idv,jdv,ie)
50	ndx=ndx+nc
99	return
	end
c***********************************************************************
	subroutine rowio(n,z,iop,idev,jdev,iend)
c  read iop<0, write iop=0, r&w iop=1
	dimension z(n)
	iend=0
	if(iop)1,2,1
1	read(idev,end=10) y,z
	if(iop)9,9,2
2	write(jdev) y,z
9	return
10	iend=1
	return
	end
c***********************************************************************
	subroutine plugm( n, z, dv )
c  plug holes using linear interpolation
	dimension z(n)
	fltbig=dv*.01
	do 1 is=1,n
	if(z(is) .lt. fltbig) go to 2
1	continue
	return
2	ix=is
3	ix=ix-1
	if(ix.lt.1) go to 4
	z(ix)=z(is)
	go to 3
4	do 5 idv=is,n
	if(z(idv) .gt. fltbig) go to 6
5	continue
	return
6	is=idv-1
	do 7 ie=idv,n
	if(z(ie) .lt. fltbig) go to 10
7	continue
	ix=is
9	ix=ix+1
	if(ix.gt.n) return
	z(ix)=z(is)
	go to 9
10	dz=(z(ie)-z(is))/float(ie-is)
	do 11 i=is+1,ie-1
11	z(i)=z(i-1)+dz
	is=ie
	go to 4
	end
c***********************************************************************
	subroutine cvc(a,i2)
c  i2=1 for lower case to upper
	character a*(*)
	n=len(a)
	if(i2.lt.1 .or. i2.gt.2) stop ' cvc: invalid convert parameter'
	do 40 i=1,n
	j=ichar(a(i:i))
	go to (10,20) i2
10	if(j.gt.122 .or. j.lt.97) go to 40
	j=j-32
	go to 30
20	if(j.gt.90 .or. j.lt.65) go to 40
	j=j+32
30	a(i:i)=char(j)
40	continue
	return
	end
c***********************************************************************
	function noyes(idum)
	character inp*4
	ic=0
	noyes=-1
1	read(5,2) inp
2	format(a4)
	if(ic.ge.3) go to 9
4	if(inp(1:1).eq.'y' .or. inp(1:1).eq.'Y') noyes=1
	if(inp(1:1).eq.'n' .or. inp(1:1).eq.'N') noyes=0
	if(noyes.gt.-1) return
      print  5
5	format(' y or n:'$)
	ic=ic+1
	go to 1
9     print 10
10	format(' count exceeded, answering no')
	noyes=0
	return
	end
c***********************************************************************
	subroutine gridr(nc,nr,zg,wz,dval,ier)
c  initialize grid with reasonable anomalies
c  wz at least max(nc,nr)
	dimension iw1(3)
	dimension zg(1),wz(1)
	data iw1/3,7,9/
      fltbig=.1704e+37
	ier=0
	nn=nc*nr
	nsep=(iw1(3)-1)/2
	ns1=nsep+1
	mxpass=max(nc,nr)/(2*nsep)
	i=1
201	if(i.gt.nn) return
	if(zg(i).gt.fltbig) go to 200
	i=i+1
	go to 201
c
c  insert control point net
c     distances for ring averages specified by iw1
200	if(nc.lt.nsep+ns1 .or. nr.lt.nsep+ns1) go to 140
	ipass=0
	iflag=1
130	iw=iw1(iflag)
	ihw=(iw-1)/2
	iset=ihw*nc+ihw
131	nass=0
	do 110 jj=ns1,nr-ihw,nsep
	ip=(jj-1)*nc+ns1
	do 100 ii=ns1,nc-ihw,nsep
	if(zg(ip).lt.fltbig) go to 100
	ips=ip-iset
	it=0
	t=0.0
	do 121 j=1,iw
	ip2=ips
	do 120 i=1,iw
	if(zg(ip2).gt.fltbig) go to 120
	t=zg(ip2)+t
	it=it+1
120	ip2=ip2+1
121	ips=ips+nc
	if(it-3.lt.0) go to 100
	zg(ip)=t/float(it)
	nass=nass+1
100	ip=ip+nsep
110	continue
	ipass=ipass+1
	if(nass.eq.0 .and. iflag.eq.3) go to 140
	if(ipass.gt.mxpass) go to 140
	if(iflag-2)133,132,131
133	iflag=2
	go to 130
132	iflag=3
	go to 130
140	continue
c	call gprint(1,1,nc,nr,zg,' ')
c
c  fill holes
	inc=nc*nsep
	j=inc+1
	if(nr.lt.ns1) go to 21
	do 20 irow=ns1,nr-nsep,nsep
	call plugm( nc, zg(j), dval )
20	j=j+inc
21	do 28 icol=1,nc
	j=icol
	do 22 k=1,nr
	wz(k)=zg(j)
22	j=j+nc
	call plugm( nr, wz, dval )
	j=icol
	do 24 k=1,nr
	zg(j)=wz(k)
24	j=j+nc
28	continue
c  final check
	do 40 i=1,nn
	if(zg(i).eq.dval) go to 41
40	continue
	return
41	t=0.0
	it=0
	do 42 i=1,nn
	if(zg(i).eq.dval) go to 42
	t=t+zg(i)
	it=it+1
42	continue
	if(it.eq.0) stop ' cannot init grid'
	t=t/float(it)
      print  43,t
43	format(' gridr init with',1pe15.5)
	do 44 i=1,nn
	if(zg(i).eq.dval) zg(i)=t
44	continue
	return
	end
c******************************************************************************
	subroutine curvmn(zg,iqd,b[huge],nc,nr,epsmx,nim,eps1,dn1,ni)
c   Applies minimum curvature equations to the first
c  nc*nr elements of array zg.
c   Array iqd contains nc*nr elements which indicate
c  for each mesh location the quadrant where a data
c  value is located. An iqd value of zero indicates
c  no data and -1 locks the present mesh value.
c   Array b should contain 6*nc*nr elements used for
c  weighting when iqd is 1 to 4, in the case where
c  iqd is only 0 or -1, b can be of length one.
c   The over-relaxation parameter w increases
c  as the system converges until 1.7 is reached.
c  Mike Webring, USGS Open-File report 81-1224.
	dimension zg(1),iqd(1),b(1)
	data nimn/5/,lmtc/1/
	if(nc.lt.5 .or. nr.lt.5) return
	ni=0
	dn=1.e20
	w=1.3
	eps=0.
	eps1=0.
	epsm=abs(epsmx)
111	continue
	if(ni.ge.nim) go to 72
	eps=0.
c first row
	if(iqd(1))2,1,1
1	zg(1)=(( (2.*(zg(2)+zg(nc+1))-zg(nc+nc+1)-zg(3))*.5 )-
     1 zg(1))*w+zg(1)
2	j1=nc+2
	j2=j1+nc
	if(iqd(2))4,3,3
3	zg(2)=(( (4.*(zg(3)+zg(j1))+2.*zg(1)-zg(4)-zg(j1-1)-
     1 zg(j1+1)-zg(j2))*.16666667 )-zg(2))*w+zg(2)
4	do 6 i=3,nc-2
	j1=i+nc
	j2=j1+nc
	if(iqd(i))6,5,5
5	zg(i)=(( (4.*(zg(i-1)+zg(j1)+zg(i+1))-zg(j1+1)-zg(j1-1)-
     1 zg(j2)-zg(i+2)-zg(i-2))*.14285714 )-zg(i))*w+zg(i)
6	continue
	if(iqd(nc-1))8,7,7
7	i=nc-1
	j1=i+nc
	zg(i)=(( (4.*(zg(i-1)+zg(j1))+2.*zg(i+1)-zg(i-2)-
     1 zg(j1+1)-zg(j1-1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
8	if(iqd(nc))10,9,9
9	j1=nc+nc
	zg(nc)=(( (2.*(zg(j1)+zg(nc-1))-zg(nc-2)-zg(j1+nc))*.5 )-
     1 zg(nc))*w+zg(nc)
c second row
10	if(iqd(nc+1))12,11,11
11	i=nc+1
	j1=i+nc
	zg(i)=(( (4.*(zg(j1)+zg(i+1))+2.*zg(1)-zg(2)-
     1 zg(i+2)-zg(j1+1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
12	if(iqd(nc+2))14,13,13
13	i=nc+2
	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i+1))+4.*(zg(jm)+zg(i-1))-
     1 2.*zg(j1+1)-zg(jm+1)-zg(j1-1)-zg(i+2)-zg(j1+nc))*
     1 5.5555556e-2 )-zg(i))*w+zg(i)
14	do 16 i=nc+3,nc+nc-2
	j1=i+nc
	jm=i-nc
	if(iqd(i))16,15,15
15	zg(i)=(( (8.*(zg(i-1)+zg(j1)+zg(i+1))+4.*(zg(jm))-
     1 2.*(zg(j1-1)+zg(j1+1))-zg(jm-1)-zg(jm+1)-
     1 zg(j1+nc)-zg(i+2)-zg(i-2))*5.263158e-2 )-zg(i))*w+zg(i)
16	continue
	i=nc+nc-1
	if(iqd(i))18,17,17
17	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i-1))+4.*(zg(jm)+zg(i+1))-2.*zg(j1-1)-
     1 zg(jm-1)-zg(j1+1)-zg(i-2)-zg(j1+nc))*5.5555556e-2 )-
     1 zg(i))*w+zg(i)
18	i=nc+nc
	if(iqd(i))20,19,19
19	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(j1)+zg(i-1))+2.*zg(jm)-zg(jm-1)-
     1 zg(i-2)-zg(j1-1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
c rows 3 to nr-2
20	do 39 j=3,nr-2
	i=(j-1)*nc+1
	if(iqd(i))22,21,21
21	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(i+1)+zg(j1)+zg(jm))-zg(j1+nc)-zg(j1+1)-zg(i+2)-
     1 zg(jm+1)-zg(jm-nc))*.14285714 )-zg(i))*w+zg(i)
22	i=i+1
	if(iqd(i))24,23,23
23	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i+1)+zg(jm))+4.*zg(i-1)
     1 -2.*(zg(j1+1)+zg(jm+1))-zg(j1-1)-zg(j1+nc)-zg(i+2)-
     1 zg(jm-nc)-zg(jm-1))*5.2631578e-2 )-zg(i))*w+zg(i)
24	do 35 j2=3,nc-2
	i=i+1
	if(iqd(i))35,25,25
25	j1=i+nc
	jm=i-nc
	d=zg(i)
	if(iqd(i))26,26,27
26	d=(( (8.*(zg(i+1)+zg(i-1)+zg(jm)+zg(j1))-2.*(zg(j1+1)+zg(jm+1)+
     1 zg(jm-1)+zg(j1-1))-zg(j1+nc)-zg(jm-nc)-zg(i-2)-zg(i+2))*
     1 .05 )-d)*w+d
	go to 33
27	ndx=(i-1)*6+1
	b1=b(ndx)
	b2=b(ndx+1)
	b3=b(ndx+2)
	b4=b(ndx+3)
	b5=b(ndx+4)
	b6=b(ndx+5)
	go to (28,29,30,31)iqd(i)
28	bu=b1*zg(jm+1)+b2*zg(jm)+b3*zg(i-1)+b4*zg(j1-1)
	go to 32
29	bu=b1*zg(jm-1)+b2*zg(jm)+b3*zg(i+1)+b4*zg(j1+1)
	go to 32
30	bu=b1*zg(j1-1)+b2*zg(j1)+b3*zg(i+1)+b4*zg(jm+1)
	go to 32
31	bu=b1*zg(j1+1)+b2*zg(j1)+b3*zg(i-1)+b4*zg(jm-1)
32	t=.25*(zg(j1+nc)+zg(i-2)+zg(jm-nc)+zg(i+2))
     1 +.5*(zg(j1-1)+zg(jm-1)+zg(jm+1)+zg(j1+1))-
     1 (zg(j1)+zg(i-1)+zg(jm)+zg(i+1))
	d=(( (bu+b5-t)*b6 )-d)*w+d
33	epsln=d-zg(i)
	if(abs(epsln).lt.abs(eps)) go to 34
	eps=epsln
	ieps=i
34	zg(i)=d
35	continue
	i=i+1
	if(iqd(i))37,36,36
36	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i-1)+zg(jm))+4.*zg(i+1)-2.*(zg(j1-1)+
     1 zg(jm-1))-zg(jm+1)-zg(jm-nc)-zg(i-2)-
     1 zg(j1+nc)-zg(j1+1))*5.2631578e-2 )-zg(i))*w+zg(i)
37	i=i+1
	if(iqd(i))39,38,38
38	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(j1)+zg(i-1)+zg(jm))-zg(jm-nc)-zg(jm-1)-zg(i-2)-
     1 zg(j1-1)-zg(j1+nc))*.14285714 )-zg(i))*w+zg(i)
39	continue
c row nr-1
40	i=(nr-2)*nc+1
	if(iqd(i))42,41,41
41	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(jm)+zg(i+1))+2.*zg(j1)-zg(jm-nc)-zg(jm+1)-
     1 zg(i+2)-zg(j1+1))*.16666667 )-zg(i))*w+zg(i)
42	i=i+1
	if(iqd(i))44,43,43
43	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i+1)+zg(jm))+4.*(zg(i-1)+zg(j1))-
     1 2.*zg(jm+1)-zg(jm-1)-zg(jm-nc)-zg(i+2)-
     1 zg(j1+1))*5.5555556e-2 )-zg(i))*w+zg(i)
44	do 46 j=3,nc-2
	i=i+1
	if(iqd(i))46,45,45
45	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i-1)+zg(jm)+zg(i+1))+4.*zg(j1)-
     1 2.*(zg(jm-1)+zg(jm+1))-zg(j1-1)-zg(i-2)-
     1 zg(jm-nc)-zg(i+2)-zg(j1+1))*5.2631578e-2 )-zg(i))*w+zg(i)
46	continue
	i=(nr-1)*nc-1
	if(iqd(i))48,47,47
47	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i-1)+zg(jm))+4.*(zg(j1)+zg(i+1))-2.*zg(jm-1)-
     1 zg(j1-1)-zg(i-2)-zg(jm-nc)-zg(jm+1))*5.5555556e-2 )-
     1 zg(i))*w+zg(i)
48	i=i+1
	if(iqd(i))50,49,49
49	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(jm))+2.*zg(j1)-zg(jm-nc)-zg(jm-1)-
     1 zg(i-2)-zg(j1-1))*.16666667 )-zg(i))*w+zg(i)
c last row
50	i=i+1
	if(iqd(i))52,51,51
51	jm=i-nc
	zg(i)=(( (2.*(zg(i+1)+zg(jm))-zg(i+2)-zg(jm-nc))*.5 )-
     1 zg(i))*w+zg(i)
52	i=i+1
	if(iqd(i))54,53,53
53	jm=i-nc
	zg(i)=(( (4.*(zg(i+1)+zg(jm))+2.*zg(i-1)-zg(i+2)-zg(jm+1)-
     1 zg(jm-nc)-zg(jm-1))*.16666667 )-zg(i))*w+zg(i)
54	do 56 j=3,nc-2
	i=i+1
	if(iqd(i))56,55,55
55	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(i+1)+zg(jm))-zg(i-2)-zg(jm-1)-
     1 zg(jm-nc)-zg(jm+1)-zg(i+2))*.14285714 )-zg(i))*w+zg(i)
56	continue
	i=i+1
	if(iqd(i))58,57,57
57	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(jm))+2.*zg(i+1)-zg(i-2)-
     1 zg(jm-1)-zg(jm-nc)-zg(jm+1))*.16666667 )-zg(i))*w+zg(i)
58	i=i+1
	if(iqd(i))60,59,59
59	jm=i-nc
	zg(i)=(( (2.*(zg(i-1)+zg(jm))-zg(i-2)-zg(jm-nc))*.5 )-
     1 zg(i))*w+zg(i)
60	if(ni)70,70,71
70	eps1=abs(eps/w)
71	ni=ni+1
	if(eps.eq.0) go to 72
	dn1=abs(eps/w)
	if(dn1.le.epsm .and. ni.ge.nimn) go to 72
	dlam=dn1/dn
	dn=dn1
	if(dlam.gt.1.) go to 74
	if(dlam.lt..8) go to 75
	if(w.ge.1.6) go to 75
	w=w+.1
	go to 75
74	if(iconv.eq.lmtc) go to 76
	iconv=iconv+1
	go to 75
76	w=w-.1*aint(dlam*10.-9.11)
	iconv=0
	if(w.lt.1.)w=1.
75	continue
	go to 111
72    return
      end
      subroutine readif(ix,x,mode)
c  To read input with <cr>-for-defaults.
c  Note this is written to minimize the amount of recoding
c  and definition of new variables needed to convert programs
c  from VAX to PC.
c
c  Call following an "Enter...[def]:" request.
c
c  mode: 1 if integer (ix); 2 if real (x) variable is expected.
c    If mode is 1, x is a dummy and is returned unchanged; if
c    mode is 2, ix is a dummy and is unchanged.
c
c    On return, mode=0 if response is <cr>, indicating default
c      selected and ix and x are returned unchanged,;
c      mode=1 or 2 if integer or real is returned, and either
c      ix or x, respectively, is read and returned;
c      mode=4 if an error occurred.
c
      character*80 ans,blank
      data blank/' '/
      if(mode.ne.1.and.mode.ne.2)then
        mode=4
        go to 99
      endif
      read(5,1) ans
1     format(a)
      if (ans.eq.blank)then
        mode=0
        go to 99
      else
        if(mode.eq.2)go to 10
        read(ans,2) ix
2       format(bn,i80)
        go to 99
10      continue
        do 4 k=80,1,-1
4       if(ans(k:k).ne.' ')go to 5
5       do 6 i=1,k
        if(ans(i:i).eq.'.')go to 7
6     continue
      ans(k+1:k+1)='.'
7     read(ans,8)x
8     format(g30.9)
      endif
99    return
      end
