      PROGRAM BADLN
C
C
C** *****************************************************************
C   REMAPP PE/3220 1985
C   REMOTE SENSING ARRAY PROCESSING PROCEDURES
C   U. S. GEOLOGICAL SURVEY, DENVER, COLORADO
C     F.KRUSE 8-85
C
C   *****************************************************************
C     PROGRAM TO INTERACTIVELY REMOVE BAD LINES BY
C     REPLACING WITH AVERAGE OF TWO ADJACENT LINES
C
C     LINK WITH DISKIO, PACK, UNPACK, REMLOG, DATE, TIME, EXIT
C
C     YOU MUST KNOW THE LINE NUMBER TO FIX BEFORE STARTING
C** *****************************************************************
C
      INTEGER*4 I, J, K, II, IK, NN, NCOUNT, NLINE, NBLINES
      INTEGER*2 IBUF(8192)
      INTEGER*2 IBUF2(8192),IBUF3(8192)
      INTEGER*4 FCB1(128),FCB2(128),TTYOUT,TTYIN
      DATA TTYIN/5/,TTYOUT/6/
C
C  log it
C
      CALL REMLOG('----- BADLN -----')
C
C     OPEN DISK INPUT FILE
C
      DO 30 I=1,128
         FCB1(I)=0
30    CONTINUE
      CALL DISKIO(0,12,IBUF,FCB1)
C
C     OPEN DISK OUTPUT FILE
C
      DO 41 I=4,128
41       FCB2(I)=0
      FCB2(1)=FCB1(1)
      FCB2(2)=FCB1(2)
      FCB2(3)=FCB1(3)
      CALL DISKIO(0,14,IBUF,FCB2)
      IF(FCB2(1).LT.0) STOP
C
C     ENTER NUMBER OF CONSECUTIVE BAD RECORDS PER BAD LINE GROUP
C
      WRITE(6,*) 'ENTER NUMBER OF CONSECUTIVE BAD RECORDS PER LINE
     C GROUP'
      READ (5,*) NN
C
C     ENTER NUMBER OF BAD LINES TOTAL TO REMOVE
C
      WRITE(6,*) 'ENTER NUMBER OF BAD LINES TO REMOVE'
      READ(5,*)NBLINES
      DO 101 IK=1,NBLINES
C
C     ENTER BAD LINE NUMBER
C
      WRITE(6,*) 'ENTER BAD LINE NUMBER - ONE LINE ONLY'
      WRITE(6,*) 'LINE NUMBER = TOP LINE OF BAD LINE GROUP'
      WRITE(6,*) 'MUST BE GREATER THAN ANY PREVIOUS BAD LINE ENTRY'
      READ(5,*) NLINE
C
C     READ SCANLINE
C
50    CALL DISKIO(9,12,IBUF,FCB1)
         NCOUNT=NCOUNT+1
         IF(FCB1(1).EQ.-1) GOTO 100
C
C     WRITE A SCANLINE
C
         CALL DISKIO(10,14,IBUF,FCB2)
         IF(NCOUNT.LT.NLINE-1) GOTO 50
C
C     UNPACK LAST LINE BEFORE BAD LINE
C
      IF(FCB1(25).EQ.8) CALL UNPACK(IBUF,FCB1)
C
C     SAVE LAST LINE BEFORE BAD LINE
C
      DO 53 J=1,FCB1(2)
         IBUF2(J)=IBUF(J)
53    CONTINUE
C     READ NN BAD LINES
      DO 903 II=1,NN
C
C     READ BAD LINE
C
         CALL DISKIO(9,12,IBUF,FCB1)
         IF(FCB1(1).EQ.-1)GOTO 100
C
903   CONTINUE
C     READ NEXT LINE
C
      CALL DISKIO(9,12,IBUF,FCB1)
C
C      UNPACK LINE AFTER BAD LINE
C
      IF(FCB1(25).EQ.8) CALL UNPACK(IBUF,FCB1)
      IF(FCB1(1).EQ.-1)GOTO 100
C
C     SAVE LINE AFTER BAD LINE
C
      DO 54 K=1,FCB1(2)
         IBUF3(K)=IBUF(K)
54    CONTINUE
C
C     CALCULATE AND WRITE NN NEW LINES TO REPLACE BAD LINES
      DO 913 II=1,NN
C
C     CALCULATE NEW LINE
C
      DO 51 J=1,FCB1(2)
         IBUF(J)=IBUF2(J)+((IBUF3(J)-IBUF2(J))*II)/(NN+1)
51    CONTINUE
C
C     PACK NEW LINE
C
      IF(FCB1(25).EQ.8) CALL PACK(IBUF,FCB1)
C
C     WRITE NEW LINE
C
      CALL DISKIO(10,14,IBUF,FCB2)
C
913   CONTINUE
C
C     PACK NEXT LINE
C
      IF(FCB1(25).EQ.8) CALL PACK(IBUF3,FCB1)
C
C     WRITE NEXT LINE
C
      CALL DISKIO(10,14,IBUF3,FCB2)
      NCOUNT=NCOUNT+NN+1
101   CONTINUE
C
C     READ AND WRITE REST OF FILE
C
52    CALL DISKIO(9,12,IBUF,FCB1)
      IF(FCB1(1).EQ.-1)GOTO 100
      NCOUNT=NCOUNT+1
      CALL DISKIO(10,14,IBUF,FCB2)
      IF(NCOUNT.LT.FCB1(3))GOTO 52
C
C     CLOSE INPUT FILE
C
100   CALL DISKIO(6,12,IBUF,FCB1)
C
C     CLOSE DISK OUTPUT FILE
C
      CALL DISKIO(6,14,IBUF,FCB2)
C
      STOP'NORMAL COMPLETION'
      END
