      PROGRAM HISTMAIN
C
C     INCLUDE 'REMAPP.HDR'
C     LINK WITH DISKIO, UNPACK, REMLOG, DATE, TIME, EXIT
C
      CHARACTER*50 PFILE
      CHARACTER*1 LABEL(60)
      INTEGER*2 IBUF(8192)
      INTEGER*4 IWIN(128),RUN
      REAL*8 GRAYLF(10000)
      LOGICAL LU
      DATA RUN/1/,GRAYLF/10000*0/
      DATA PFILE/'HISTMAIN.OUT'/
C.....OPEN HISTOGRAM SAVE FILE
c7      INQUIRE(7,OPENED=LU)
c7      IF(LU) THEN
c7      ELSE
c7         OPEN(7,FILE='NULL',IOSTAT=ISTAT)
c7      ENDIF
C.....OPEN HISTOGRAM LISTING FILE
      OPEN(3,FILE=PFILE,STATUS='NEW',FORM='FORMATTED',
     &RECL=128,IOSTAT=ISTAT,ERR=988)
988   IF(ISTAT.NE.0) THEN
      WRITE(6,*)' RENAME or DELETE Text File HISTMAIN.OUT'
      CALL EXIT(255)
      ENDIF
1     DO 2 I=1,30
2     IWIN(I)=0
15    FORMAT(G16.0)
C...DOCUMENTATION FOR A JOB
      CALL REMLOG('!!!!! HISTOGRAM !!!!!        ')
C.....OPEN INPUT FILE
          CALL DISKIO(0,10,IBUF,IWIN)
      IF(IWIN(1).LT.0) CALL EXIT(3)
        WRITE(6,36)
36        FORMAT(1X,'TITLE FOR OUTPUT (60 CHARACTERS) ')
        READ(5,50) LABEL
50        FORMAT(60A1)
41        WRITE(6,40)
        READ(5,*)MIND,MAXD
      IF(MIND.LT.0.OR.MAXD.LT.0) GO TO 100
      GO TO 110
100   WRITE(6,990)
990      FORMAT(' ERROR!  MIN OR MAX DENSITY LESS THAN ZERO.
     +THE PROGRAM DOES NOT ALLOW NEGATIVE NUMBERS.')
      GO TO 41
110        NSIZE=0
        DO 42 JK=1,10000
42        GRAYLF(JK)=0.0
        NSIZE=ABS(MAXD-MIND)+1
      IF(MAXD.LE.10000) GO TO 120
      WRITE(6,991)
991   FORMAT(/' ERROR! MAX. DENSITY > 10000!')
      GO TO 41

C.......IAMAX IS USED TO PASS THE ABSOLUTE MAXIMUM DN VALUE
C
120        IAMIN=MIND
        IAMAX=MAXD
        IF(NSIZE.LT.10000)GO TO 43
        MIND=1
        MAXD=10000
C...DOCUMENTATION FOR A JOB
43    WRITE(4,'(/)')
      WRITE(4,360)
360      FORMAT(8X,'OUTPUT TITLE',/)
      WRITE(4,500) LABEL
500      FORMAT(8X,60A1,/)
      WRITE(4,510) IAMIN,IAMAX
510      FORMAT(8X,' MIN AND MAX DN',I5,3X,I5)
        CALL HIST (MIND,MAXD,GRAYLF,NSIZE,IAMIN,IAMAX,RUN,IBUF,IWIN,
     # LABEL)
C***CLOSE OPENED FILE
        CALL DISKIO(6,10,IBUF,IWIN)
C
C        RETURN TO HERE TO ASK IF YOU WANT TO GO ON
C
        WRITE(6,45)
        READ(5,25)IOK
25        FORMAT(A1)
        IF((IOK.EQ.'N').OR.(IOK.EQ.'n'))  GO TO 10000
        RUN=RUN+1
        WRITE(6,30)RUN
        IWIN(1)=0
        GO TO 1
30      FORMAT(/1X,' RE-ENTER ALL WINDOW PARAMETERS, JOB ',I4)
40      FORMAT(/1X,'INPUT MIN AND MAX DENSITY VALUES   *')
45        FORMAT(/1X,'PROCESS ANOTHER FILE ? YES OR NO  *')
10000  STOP'HISTOGRAM'
        END
C** *****************************************************************
C
C   REMAPP P-E 3200 1980
C   REMOTE SENSING ARRAY PROCESSING PROCEDURES
C   U. S. GEOLOGICAL SURVEY, DENVER, COLORADO
C   BRANCH OF PETROPHYSICS AND REMOTE SENSING
C   GARY L. RAINES
C
C   HIST.FORTRAN     SUBROUTINE FOR HISTOGRAM_MAIN.FORTRAN
C   *****************************************************************
        SUBROUTINE HIST(MIND,MAXD,GRAYLF,NSIZE,IAMIN,IAMAX,IRUN,
     # IBUF,IWIN,LABEL)
      INTEGER*4 NPLOT(51),IPLOT(51),IWIN(1)
      CHARACTER*4 JDATE(3),ITIME(3)
      REAL*8 GRAYLF(10000)
      CHARACTER*1 LABEL(60)
      INTEGER*2 IBUF(1)
      DATA IAST/'*'/,NPLOT/51*' '/,LOW/0/,IHIGH/0/
      DATA IPLOT/'+',9*' ','+',9*' ','+',9*' ','+',9*' ','+',9*' ',
     #   '+'/,CC/'*'/
C
C       HIST ALLOWS THE USER TO SET A DENSITY VALUE WINDOW
C       ONLY VALUES WITHIN THIS RANGE WILL APPEAR ON THE
C       HISTOGRAM , VALUES EITHER ABOVE OR BELOW THIS RANGE
C       WILL APPEAR AS 'HIGH' AND 'LOW' RESPECTIVELY.
C
C       MIND   LOW RANGE OF DENSITY WINDOW
C       MAXD   HIGH RANGE OF DENSITY WINDOW
C
C       ***************************************************
c     IRUN VAR NOT USED
      IRUN=0
         LOW=0
        IHIGH=0
        MIN=MIND
        MAX=MAXD
        NUMP=IWIN(2)
        NUML=IWIN(3)
        SUMX=0.
        DVSUM=0.
        GLFSQ=0.0
        GLSQF=0.0
        IF(NSIZE.GT.10000)GO TO 9
C
C......READ INPUT FILE  DN RANGE LE 10000
C
        DO 3 LNO=1,NUML
        CALL DISKIO(9,10,IBUF,IWIN)
      IF(IWIN(1).EQ.-1) GOTO 44
      IF(IWIN(1).LT.-1) CALL EXIT(3)
      IF(IWIN(25).EQ.8) CALL UNPACK(IBUF,IWIN)
        DO 3 J=1,NUMP
        JJ=IBUF(J)
        IF(JJ.LT.IAMIN)LOW=LOW+1
        IF(JJ.GT.MAXD)IHIGH=IHIGH+1
        IF(JJ.LT.IAMIN.OR.JJ.GT.MAXD)GO TO 3
        DVSUM=DVSUM+JJ
      JJ=JJ+1
        GRAYLF(JJ)=GRAYLF(JJ)+1.0
3        CONTINUE
      MIND=MIND+1
      MAXD=MAXD+1
        GO TO 15
C
C......READ INPUT FILE   DN RANGE GT 10000
C
9        AM=10000.0/FLOAT(NSIZE)
        AB=(-AM)*IAMIN+MIND
        AMC=FLOAT(NSIZE)/10000.000
        ABC=(-AMC)*MIND+IAMIN
        DO 11 LNO=1,NUML
        CALL DISKIO(9,10,IBUF,IWIN)
      IF(IWIN(1).EQ.-1) GOTO 44
      IF(IWIN(1).LT.-1) CALL EXIT(3)
      IF(IWIN(25).EQ.8) CALL UNPACK(IBUF,IWIN)
        DO 11 J=1,NUMP
        IF(IBUF(J).LT.IAMIN)LOW=LOW+1
        IF(IBUF(J).GT.IAMAX)IHIGH=IHIGH+1
        IF(IBUF(J).LT.IAMIN.OR.IBUF(J).GT.IAMAX)GO TO 11
        DVSUM=DVSUM+IBUF(J)
        JJ=IBUF(J)*AM+AB
        GRAYLF(JJ)=GRAYLF(JJ)+1.0
11        CONTINUE
      MIND=MIND+1
      MAXD=MAXD+1
15        TSAMPS=NUMP*NUML
        ASAMPS=TSAMPS-(LOW+IHIGH)
C       ///// AVEGL IS THE AVERAGE GRAY SCALE /////
        AVEGL=DVSUM/ASAMPS
C
C.......FIND THE STANDARD DEVIATION
C
        DO 18 I=MIND,MAXD
        GLSQF = (FLOAT(I)**2)*GRAYLF(I) + GLSQF
        GLFSQ = (FLOAT(I)*GRAYLF(I)) + GLFSQ
18        CONTINUE
        VAR = ((ASAMPS*GLSQF)-(GLFSQ**2))/(ASAMPS*(ASAMPS-1))
        STD=SQRT(VAR)
C
C       NOW FIND FREQUENCY RANGE IF WANTED
C
        NEWMAX=MAXD
        NEW=1
        WRITE(6,30)
        READ(5,*)NEW
        IF(NEW.EQ.1) GO TO 8
        I1=MIND
        MAXD=MAXD+NEW-1
        MIND=MIND+NEW-1
        I2=MIND
19        DO 31 JX=I1,I2
31        ACUM=GRAYLF(JX)+ACUM
        GRAYLF(I2)=ACUM
        ACUM=0
        I1=I1+NEW
        I2=I2+NEW
        IF(I2.LT.NEWMAX) GO TO 19
        I2=NEWMAX
        IF(I1.LT.NEWMAX) GO TO 19
8        PERCNT=0.0
        INDEX=MIND
C
C...... FIND THE MODE AND MAX DN FREQUENCY
C
        DO 33  I=MIND,MAXD
33        IF(GRAYLF(I).GT.GRAYLF(INDEX)) INDEX=I
        FQMAX=GRAYLF(INDEX)
      IF(NSIZE.LE.10000) INDEX=INDEX-1
        IF(NSIZE.GT.10000)INDEX=INDEX/AMC+ABC
C
C       ///// WRITE ON IO HEADING INFORMATION /////
C
C     IF(IRUN.EQ.1) WRITE(3,60) LABEL
C     IF(IRUN.GT.1) WRITE(3,61) LABEL
      CALL DATE(JDATE)
      CALL TIME(ITIME)
      WRITE(3,999) LABEL,JDATE(1),JDATE(2),JDATE(3),ITIME(1),
     &ITIME(2),ITIME(3)
999   FORMAT(1X,60A1,/1X,3A4,' ',3A4)
      WRITE(3,20) IWIN(5),IWIN(4),NUML,NUMP,IWIN(7),
     # IWIN(6),IAMIN,IAMAX,AVEGL,INDEX,FQMAX,TSAMPS,LOW,
     # IHIGH,ASAMPS
        WRITE(3,21) VAR,STD
C
C       ///// THE FOLLOWING DOES THE HISTOGRAM PLOTTING /////
C

        WRITE(3,600)
        WRITE(3,610)(IPLOT(I),I=1,51)
        DO 200 KK=MIND,MAXD,NEW
        I=KK
        IF(I.GT.NEWMAX)I=NEWMAX
      IX=I-1
        IF(NSIZE.LE.10000)GO TO 299
        IX=I*AMC+ABC
299        NORM=((GRAYLF(I)/FQMAX)*100.0+1.5)/2.0
        DO 300 J=1,NORM
300        NPLOT(J) = IAST
        NORM1=NORM+1
        IF(NORM1.EQ.52) GO TO 330
        DO 320 K=NORM1,51
320        NPLOT(K)=IPLOT(K)
330        PERCNT=(GRAYLF(I)/ASAMPS*100.0)+PERCNT
      IF(PERCNT.GE..1.AND.PERCNT.LE.99.9) THEN
        WRITE(3,620) CC, IX,GRAYLF(I),PERCNT,(NPLOT(J),J=1,51)
c7      WRITE(7,*) IX,GRAYLF(I),PERCNT
      ENDIF
200        CONTINUE
30        FORMAT(1X,'ENTER CLASS FREQUENCY   ')
35        FORMAT(G16.0)
20    FORMAT(//' START LINE',I4,'; START PIXEL',I4,'; NO. LINES',
     #  I4,'; NO. PIXEL',I4/1X,'LINE SKIP',I5,'; PIXEL SKIP',I5//
     # 1X,'MIN GRAY LEVEL',I6,'; MAX GRAY LEVEL',I6,'; MEAN GRAY LEVEL',
     #  F8.1/1X,'MODE:  GRAY LEVEL',I6,' OCCURS',F13.0,' TIMES'/
     #  1X,'TOTAL PIXELS TESTED',5X,F15.0/
     #  1X,'LOW PIXELS',I7,'; HIGH PIXELS',I7/
     #  1X,'PIXELS USED IN HISTOGRAM',F15.0/)
21        FORMAT(1X,'VARIANCE ',F10.3,' STANDARD DEVIATION ',F10.3)
60    FORMAT(1X,4X,60A1//)
61    FORMAT(1H1,4X,60A1//)
600        FORMAT(//,1X,'FREQUENCY HISTOGRAM-NORMALIZED TO 50'//
     #    1X,'GRAYL',3X,'FREQ',3X,'CUM%',1X,'0',8X,'20',8X,'40',
     #    8X,'60',8X,'80',7X,'100'/)
610        FORMAT(21X,51A1)
620        FORMAT(A1,I7,F7.0,F6.1,51A1)
44      RETURN
        END
