      PROGRAM REMROT
C*****************************************************************
C  REMAPP VERSION 2  (PC)
C
C  PROGRAM ROTATES REMAPP IMAGE 90 DEGREES CLOCKWISE
C            MUST BE SINGLE BAND; 8 OR 16 BIT DATA
C
C  LINK WITH DISKIO, PACK, UNPACK
C
C
C                   Max Scanlines = 16,384
C                   Max Pixels = 16,384
C*****************************************************************
C
      INTEGER*4 IN(256),OUT(256),INPIX,I,NEXT,IPIXST,IPIXOUT,ISLOUT
      INTEGER*4 MAXSL, PIXLIMIT, SLLIMIT,ITOPREC
      INTEGER*2 JBUF(16384)
      INTEGER*2 IBUF(172032)
      DATA IN,OUT/256*0,256*0/
      DATA JBUF/16384*0/
C
C  set max SL * Pix read at once to 172,032  (16384 * 21)
C
      MAXSL = 172032 
      PIXLIMIT = 16384
      SLLIMIT = 16384
C
C  SLLIMIT can be set up to the max allowed for record writes by conpiler
C    or 172,032, which ever is smaller
C
C  Note: Max scanlines out = Max pixels in (or 16,834)
C
C  LOGIT
C
      CALL REMLOG('******   REMROT   ******')
C
C  OPEN INPUT FILE
C
      IN(1)=0
      CALL DISKIO(0,10,JBUF,IN)
      IF(IN(1).LT.0) CALL EXIT(3)
C
      IF(IN(3).GT.SLLIMIT) 
     & STOP 'Error: Maximum # of scanlines on input = 16,384'
      IPIXOUT=IN(3)
      IF(IN(2).GT.PIXLIMIT)
     & STOP 'Error: Maximum # of pixels on input = 16,384'
      ISLOUT=IN(2)
      INPIX = MIN(IN(2),MAXSL/IPIXOUT)
C
C  OPEN OUTPUT FILE
C
      OUT(1)=IN(25)
      OUT(2)=IPIXOUT
      IF ((IN(22).LE.1) .AND. (IN(13).GT.1))
     & STOP'ERROR: PROGRAM ONLY OUTPUTS SINGLE BAND IMAGE FILES'
      OUT(13)=1
      CALL DISKIO(0,11,JBUF,OUT)
      IF(OUT(1).LT.0) CALL EXIT(3)
      IPIXST = IN(4)
      ITOPREC=IN(14)
C
      DO 11, I = 1, IN(2), INPIX
         NEXT=IPIXOUT
C
C  REW FILE TO SUBSET STARTING RECORD
C
         IN(14)=ITOPREC
C
12       CALL DISKIO(9,10,JBUF,IN)
         IF(IN(1).LT.0) THEN
            IF(IN(1).EQ.-1) GOTO 11
            IF(IN(1).LT.-1) CALL EXIT(3)
         ELSE

c  for remapp version 3            CALL UNPACK(JBUF,IN)

            IF(IN(25).EQ.8) CALL UNPACK(JBUF,IN)
            CALL ROTATE(IBUF,IPIXOUT,INPIX,NEXT,JBUF,I,ISLOUT)
            NEXT = NEXT-1
            GOTO 12
         ENDIF
11    CALL DISKOUT(IBUF,JBUF,IN(2),IPIXOUT,INPIX,OUT)
C
      CALL DISKIO(6,10,JBUF,IN)
      CALL DISKIO(6,11,JBUF,OUT)
C
      STOP
      END
C
C
C
      SUBROUTINE ROTATE(IBUF,NOUTPIX,NOUTLINES,NEXT,JBUF,I,ISLOUT)
      INTEGER*4 NOUTPIX,NOUTLINES,NEXT,I,J,ISLOUT
      INTEGER*2 IBUF[HUGE](NOUTPIX,NOUTLINES)
      INTEGER*2 JBUF(ISLOUT)
      DO 1,J=I,NOUTLINES+(I-1)
C
C fix image out scanline count if want BIL files (&NEXT count in main prog)
C IMAGE OUT(PIX,  SL ) = IMAGE IN(PIX)
C
1     IBUF(NEXT,J-I+1) = JBUF(J)
      RETURN
      END
C
C
C
      SUBROUTINE DISKOUT(IBUF,JBUF,NLINES,NOUTPIX,NOUTLINES,OUT)
      INTEGER*4 OUT(256),NLINES,NOUTPIX,NOUTLINES,I,J
      INTEGER*2 IBUF[HUGE](NOUTPIX,NOUTLINES),JBUF(NOUTPIX)
      DO 1,I=1,NOUTLINES
         IF(OUT(24).LT.NLINES) THEN
            DO 20,J=1,NOUTPIX
               JBUF(J)=IBUF(J,I)
20          CONTINUE
            IF(OUT(25).EQ.8) CALL PACK(JBUF,OUT)
            CALL DISKIO(10,11,JBUF,OUT)
            IF(OUT(1).LT.0) CALL EXIT(3)
         ENDIF
1     CONTINUE
      RETURN
      END
