      PROGRAM GRDREM16
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  PROGRAM CONVERTS USGS STD. GRID FILES TO REMAPP IMAGE FILES
C  ***  NOTE: IMAGE IS UPSIDEDOWN & REVERSED, USE REMFLIP TO RIGHT ***
C     SCALES GRID REAL*4 DATA TO 16 BITS/PIXEL  (DN = 0-20000)
C
C  LINK WITH DISKIO, REMLOG, DATE, TIME, EXIT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      REAL*4 ROW(8192),VMIN/1E38/,VMAX/-1E38/,NSUM/0./
      REAL*4 XO, DXO, YO, DYO
      REAL*8 VSUM/0./,VMEAN/0./
      INTEGER*2 IROW(8192)
      INTEGER*4 OFCB(128), ICOL, NCOL, NROW, NW
      CHARACTER*56 ID
      CHARACTER*8 PGM
      CHARACTER SCALING*2, FILENAME*80
      REAL*4 IDVAL/1E30/
      CALL REMLOG('> > Grid - Remapp < <')
c.....open grid file
      WRITE(6,80)
80    FORMAT(1X,'GRID FILENAME = ',\)
      READ(5,90) FILENAME
90    FORMAT(80A)
      OPEN(13,FILE=FILENAME,STATUS='OLD',ACCESS='SEQUENTIAL',
     & FORM='UNFORMATTED')
      READ(13) ID,PGM,NCOL,NROW,NW,XO,DXO,YO,DYO
      write(*,*) id,pgm,ncol,nrow,nw,xo,dxo,yo,dyo
c
c.....create remapp file
c
      ICOL=NCOL
      IF(ICOL.LT.100) ICOL=100
      OFCB(1)=16
      OFCB(2)=ICOL
      OFCB(13)=1
      CALL DISKIO(0,12,IROW,OFCB)
      IF(OFCB(1) .LT. 0) CALL EXIT(3)
c.....change standard grid to remapp file
      WRITE(6,*) 'Scaled(S),Self-scaled(SS),Unscaled(U)'
      READ(5,'(A2)') SCALING
      IF(SCALING.EQ.'S'.OR.SCALING.EQ.'s') THEN
         write(6,*) 'Enter Data min, max, mean'
         read(5,*) vmin,vmax,VMEAN
         ELSEIF(SCALING.EQ.'SS'.OR.SCALING.EQ.'ss') THEN
            DO 110 I=1,NROW
               READ(13) IDUM,(ROW(J),J=1,NCOL)
               DO 100 J=1,NCOL
                  IF(ROW(J).EQ.IDVAL) GOTO 100
                  VMIN=MIN(VMIN,ROW(J))
                  VMAX=MAX(VMAX,ROW(J))
                  VSUM=VSUM+ROW(J)
                  NSUM=NSUM+1
100            CONTINUE
110         CONTINUE
            VMEAN=VSUM/NSUM
      ENDIF
      WRITE(6,*) 'Vmin/mean/max = ',VMIN,VMEAN,VMAX
      RANGE = MAX(VMAX-VMEAN,VMEAN-VMIN)
      VMIN=VMEAN-RANGE
      VMAX=VMEAN+RANGE
      FACTOR = 20000./(2*RANGE)
c.....open grid file
      REWIND 13
      READ(13) ID,PGM,NCOL,NROW,NW,XO,DXO,YO,DYO
c.....loop
5     READ(13,END=7) DUM,(ROW(I),I=1,NCOL)
         DO 6 I=1,NCOL
         IF(SCALING.NE.'U'.AND.SCALING.NE.'u') THEN
            IROW(I) = MAX(0.,MIN((ROW(I) - VMIN) * FACTOR,20000.))
         ELSE
            IROW(I) = MAX(0.,MIN(ROW(I),20000.))
         ENDIF
6        CONTINUE
         CALL DISKIO(10,12,IROW,OFCB)
         IF(OFCB(1) .LT. 0) CALL EXIT(3)
      GOTO 5
7     CALL DISKIO(6,12,IROW,OFCB)
      CLOSE(13)
      STOP
      END
