      PROGRAM REMGRD
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  PROGRAM CONVERTS REMAPP IMAGE FILES TO USGS STD. GRID FILES
C  ***  NOTE: GRID Files start at bottom of image  ***
C             REMAPP images start at top of image
C     SCALES 8 OR 16 BITS/PIXEL  (DN = 0-255 or 0-32,767) TO 
C     GRID REAL*4 DATA (1 FOR 1:  0.0 - 255.0 or 0.0 - 32,767.0)
C        & flips image bottom to top
C
C  LINK WITH DISKIO, UNPACK, REMLOG, DATE, TIME, EXIT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      REAL*4 ROW(8192)
      REAL*4 XO, DXO, YO, DYO, DUM, DVAL
      INTEGER*2 IROW(8192)
      INTEGER*4 ifcb(256), NCOL, NROW, NW, I, J, MIN, MAX
      CHARACTER*56 ID
      CHARACTER*8 PGM
      CHARACTER FILENAME*80
 
      DUM = 0.0
      MIN = 1
      DVAL = 1E30
 
      CALL REMLOG('--- *** Remapp -> Grid   (GRDREM) *** ---')
c
c.....open remapp file
c
      ifcb(1)=0
      CALL DISKIO(0,12,IROW,ifcb)
      IF(ifcb(1) .LT. 0) CALL EXIT(3)

c.....open grid file
      WRITE(6,80)
CBSD480    FORMAT(1X,'GRID FILENAME = ',$)
CMSPC80    FORMAT(1X,'GRID FILENAME = ',\)
80    FORMAT(1X,'GRID FILENAME = ',\)
      READ(5,90) FILENAME
90    FORMAT(80A)
      OPEN(13,FILE=FILENAME,STATUS='NEW',ACCESS='SEQUENTIAL',
     & FORM='UNFORMATTED')
      WRITE(4,*) 'GRID file opened: ', filename

c  write grid header record

      id = filename
      pgm = 'REM>GRID'
      ncol = ifcb(2)
      nrow = ifcb(3)
      nw = 1
      xo = 1.0
      dxo = 1.0
      yo = 1.0
      dyo = 1.0

      WRITE(13) ID,PGM,NCOL,NROW,NW,XO,DXO,YO,DYO

      write(4,*) 'id,pgm,ncol,nrow,nw,xo,dxo,yo,dyo ='
      write(6,*) 'id,pgm,ncol,nrow,nw,xo,dxo,yo,dyo ='
      write(4,*) id,pgm,ncol,nrow,nw,xo,dxo,yo,dyo
      write(6,*) id,pgm,ncol,nrow,nw,xo,dxo,yo,dyo

      if(ifcb(25).eq.8) then
         max = 255
      else
         max = 32767
      endif

      write(4,*) 'Minimum Values:  REMAPP DN = ', min,'  Grid = ', min
      write(4,*) 'Maximum Values:  REMAPP DN = ', max,'  Grid = ', max
      write(4,*) 'DVAL:  REMAPP DN = 0,  Grid = ', DVAL   
      write(6,*) 'Minimum Values:  REMAPP DN = ', min,'  Grid = ', min
      write(6,*) 'Maximum Values:  REMAPP DN = ', max,'  Grid = ', max
      write(6,*) 'DVAL:  REMAPP DN = 0,  Grid = ', DVAL
 
c.....loop  read/write
 
      DO 15 J=NROW, 1, -1

c         ifcb(14) = J + 1  (remapp version 1)
         ifcb(14) = J + 1
c         ifcb(14) = J      (remapp version 2 & 3)
         call diskio(9,12,irow,ifcb)
         if(ifcb(1) .lt. 0) goto 999
c         if(ifcb(25).eq.8) call unpack(irow,ifcb)  (remapp version 1 & 2)
         if(ifcb(25).eq.8) call unpack(irow,ifcb)
c         call unpack(irow,ifcb) (remapp version 3)

         DO 6 I=1, NCOL
            ROW(I) = real(IROW(I))
            if (IROW(I).eq.0) ROW(I) = DVAL
6        CONTINUE

c  write out grid record      

      write(13) DUM,(ROW(I),I=1,NCOL)
      II = J

15    CONTINUE
 
7     IF(II .NE. 1) THEN
         DO 20 J=1, NCOL
            ROW(J)=0.0
20       CONTINUE
         DO 25 J=II-1, 1, -1
            write(13) DUM,(ROW(I),I=1,NCOL)
25       CONTINUE
      ENDIF
 
C.....CLOSE FILES
999   CALL DISKIO(6,12,IROW,ifcb)
      CLOSE(13)
 
      STOP
      END
